﻿:Namespace SAWS
⍝ === VARIABLES ===

    AltRequest←''

    AltResponse←''

    DEBUG←0

    LastCallRequest←''

    LastCallResponse←''

    LastRunRequest←''

    LastRunResponse←''

    SAWS_Error←''

    SILENT←0

    _←⍬
    _,←,⊂'<style type="text/css">    '
    _,←,⊂'        BODY { color: #000000; background-color: white; font-family: Verdana; margin-left: 0px; margin-top: 0px; }'
    _,←,⊂'        #content { margin-left: 30px; font-size: .70em; padding-bottom: 2em; }'
    _,←,⊂'        A:link { color: #336699; font-weight: bold; text-decoration: underline; }'
    _,←,⊂'        A:visited { color: #6699cc; font-weight: bold; text-decoration: underline; }'
    _,←,⊂'        A:active { color: #336699; font-weight: bold; text-decoration: underline; }'
    _,←,⊂'        A:hover { color: cc3300; font-weight: bold; text-decoration: underline; }'
    _,←,⊂'        P { color: #000000; margin-top: 0px; margin-bottom: 12px; font-family: Verdana; }'
    _,←,⊂'        pre { background-color: #e5e5cc; padding: 5px; font-family: Courier New; font-size: x-small; margin-top: -5px; border: 1px #f0f0e0 solid; }'
    _,←,⊂'        td { color: #000000; font-family: Verdana; font-size: .7em; }'
    _,←,⊂'        h2 { font-size: 1.5em; font-weight: bold; margin-top: 25px; margin-bottom: 10px; border-top: 1px solid #003366; margin-left: -15px; color: #003366; }'
    _,←,⊂'        h3 { font-size: 1.1em; color: #000000; margin-left: -15px; margin-top: 10px; margin-bottom: 10px; }'
    _,←'        ul { margin-top: 10px; margin-left: 20px; }' '        ol { margin-top: 10px; margin-left: 20px; }'
    _,←'        li { margin-top: 10px; color: #000000; }' '        font.value { color: darkblue; font: bold; }'
    _,←'        font.key { color: darkgreen; font: bold; }' '        font.error { color: darkred; font: bold; }'
    _,←,⊂'        .heading1 { color: #ffffff; font-family: Tahoma; font-size: 26px; font-weight: normal; background-color: #003366; margin-top: 0px; margin-bottom: 0px; margin-left: -30px; padding-top: 10px; padding-bottom: 3px; padding-left: 15px; width: 105%; }'
    _,←,⊂'        .button { background-color: #dcdcdc; font-family: Verdana; font-size: 1em; border-top: #cccccc 1px solid; border-bottom: #666666 1px solid; border-left: #cccccc 1px solid; border-right: #666666 1px solid; }'
    _,←,⊂'        .frmheader { color: #000000; background: #dcdcdc; font-family: Verdana; font-size: .7em; font-weight: normal; border-bottom: 1px solid #dcdcdc; padding-top: 2px; padding-bottom: 2px; }'
    _,←,⊂'        .frmtext { font-family: Verdana; font-size: .7em; margin-top: 8px; margin-bottom: 0px; margin-left: 32px; }'
    _,←,⊂'        .frmInput { font-family: Verdana; font-size: 1em; }'
    _,←'        .intro { margin-left: -15px; }           ' ' </style>' ''
    STYLE←_

    Service←''

    TIMEOUT←20000

    TRACE←0

    URL←''

    Version←20110331.1
    
    DRC←#.DRC

    ⎕ex '_'

⍝ === End of variables definition ===

    ⎕IO ⎕ML ⎕WX←1 3 3

    ∇ r←larg Call rarg;service;method;arg;ok;cmd;port;req;hdr;z;page;protocol;host;lchost;req2send;mask;tmp;ss;http;body;resp;soapaction;xmlns;cert;secure;ssl;length;t;m
          ⍝ Invoke a Web Service
     
          ⍝ larg[1] - host name
          ⍝ larg[2] - port number (defaults to 80 for http, 443 for https)
          ⍝ larg[3] - page name (defaults to service name)
          ⍝ larg[4] - soapaction (if empty, we build a default value)
          ⍝ larg[5] - Client certificate
          ⍝ larg[6] - SSLValidation flags (see Conga documentation)
     
          ⍝ rarg takes one of two forms:
          ⍝  1) a simple character vector representing the entire SOAP over HTTP message; OR
          ⍝  2) a 3 item nested vector containing:
          ⍝     [1] service - web service name
          ⍝     [2] method - web service method to execute
          ⍝     [3] arg which can take two forms:
          ⍝          1) a simple character vector representing the entire SOAP message (we build the HTTP part); OR
          ⍝          2) the arguments to the web service method in one of the following forms:
          ⍝             ('name' 'value' {'name2' 'value2' ... 'nameN' 'valueN'})
          ⍝             (N,2)⍴'name' 'value' ... 'nameN' 'valueN'
          ⍝             (('name' 'value'){('name2' 'value2')...('nameN' 'valueN')})
          ⍝             (N,3)⍴ level 'name' 'value' ... levelN 'nameN' 'valueN'
     
          ⍝ r[1] return code (0=no error, 1=SOAP Fault, 2=Conga Error, 3=HTTP Error, ¯1=could not understand request)
          ⍝  [2] details if an error, or the result of the SOAP call
     
      :If 0≠1⊃z←DRC.Init'' ⋄ r←2 z ⍝ flag Conga error
          :GoTo exit
      :EndIf
     
      :If 1=≡larg ⋄ larg←,⊂larg ⋄ :EndIf ⍝ if only host name supplied nest it
      larg←6↑larg,(⍴,larg)↓''⍬'' '' '' 0
      host port page soapaction cert ssl←larg
      secure←IsSecure cert
     
      lchost←HTTPUtils.lc host
          ⍝ First try to figure out protocol
      :If 'http://'≡7↑lchost ⋄ protocol←'http://' ⋄ host←7↓host
      :ElseIf 'https://'≡8↑lchost ⋄ protocol←'https://' ⋄ host←8↓host
      :Else ⋄ protocol←'http',(~secure)↓'s://' ⍝ default to HTTP{S}
      :EndIf
     
      :If 1=≡rarg ⋄ req2send←rarg ⍝ if simple vector supplied, it's the entire SOAP over HTTP message
      :Else
          service method arg←rarg ⍝ otherwise, decompose right argument
     
          :If 0∊⍴,port ⋄ port←(1+protocol≡'https://')⊃80 443 ⋄ :EndIf ⍝ if port isn't supplied, use 80 or 443 if using SSL
          :If 0∊⍴,page ⋄ page←service ⋄ :EndIf ⍝ default page is the same as the service name
          :If 0∊⍴,host ⋄ host←'localhost' ⋄ :EndIf ⍝ default host is localhost
     
          :If 0∊⍴arg ⋄ arg←'' '' ⍝ arg is empty, supply default of no parameters for method
          :ElseIf (2=≡arg)∧(1=⍴⍴arg)∧0=2|¯1↑⍴arg ⋄ arg←((0.5××/⍴arg),2)⍴arg ⍝ arg is a vector of name/value pairs
          :ElseIf (3=≡arg)∧1=⍴⍴arg ⋄ arg←⊃arg ⍝ arg is a vector of nested name/value pairs (('name1' 'value1')('name2' 'value2'))
          :EndIf
     
          :If 1<≡arg
              :If 2=¯1↑⍴arg ⋄ arg←1,((¯2↑1,⍴arg)⍴arg),⊂⍬
              :Else ⋄ arg←4↑[2]arg,⊂⍬
              :EndIf⍝ 0 2⍴0 ⍝ Make correctly formed "MLS"
          :EndIf
     
          service,←(0≠⍴service)/'/'
          method xmlns←method{((⍵-1)↑⍺)(⍵↓⍺)}1⍳⍨' xmlns='⍷method
          :If 0∊⍴xmlns ⋄ xmlns←'xmlns="',protocol,host,((0≠⍴service)/'/',service),'"' ⋄ :EndIf
     
          :If 1=≡arg ⋄ req←arg ⍝ if arg is simple vector, use it as the SOAP message
          :Else
              req←1 SOAP.EncodeRequest(method,' ',xmlns)arg ⍝ SOAP-encoded request
          :EndIf
     
          host←(-'/'=¯1↑host)↓host
          :If 0∊⍴soapaction ⋄ soapaction←' '~⍨'"',protocol,host,'/',service,method,'"' ⋄ :EndIf
     
          hdr←'POST /',page,' HTTP/1.1',NL
          hdr,←'Host: ',host,NL
          hdr,←'SOAPAction: ',soapaction,NL
          hdr,←'Content-Type: text/xml; charset=utf-8',NL
          hdr,←'Content-Length: ',⍕⍴req
     
          req2send←hdr,NL,NL,req
      :EndIf
     
      :If DEBUG bit 1 ⋄ LastCallRequest←req2send ⋄ :EndIf
      :If DEBUG bit 2 ⋄ :AndIf 0<⍴AltRequest ⋄ req2send←AltRequest ⋄ :EndIf
     
      :If TRACE bit 0
          ss←(1+∨/NL⍷req2send)⊃(⎕UCS 13 13)(NL,NL)
          1 Output'>>> SAWS.Call <<<'
          1 Output'hdr= ',terse((~mask←∨\ss⍷req2send)/req2send)~⎕UCS 10
          1 Output'req= ',terse tmp←(⍴ss)↓mask/req2send
          1 Output'xml= ',terse ⎕XML ⎕XML tmp
      :EndIf
     
      ok cmd←2↑z←DRC.Clt''host port'Text',secure/('X509'cert)('SSLValidation'ssl) ⍝ Connect to server
      :If 0≠ok ⋄ r←2 z ⍝ flag Conga error
          :GoTo exit
      :EndIf
     
      :If 0≠1⊃z←DRC.Send cmd req2send
          r←2 z ⍝ Send it (flag Conga error, if any)
          :GoTo exit
      :EndIf
     
      resp←'' ⍝ initialize the response
      length←0
     
      :Repeat
          :If 0≠1⊃z←DRC.Wait cmd TIMEOUT              ⍝ Loop, collecting pieces of response
              r←2 z ⍝ flag Conga error
              {}DRC.Close cmd
              :GoTo exit
          :ElseIf z[3]∊'Block' 'BlockLast'
              resp←resp,4⊃z
              :Trap 0
                  :If length=0
                  :AndIf ∨/m←(NL,NL)⍷resp
                  :AndIf ~0∊⍴t←(2⊃HTTPUtils.DecodeHeader resp)HTTPUtils.GetValue'content-length' 'Numeric'
                      length←t+3+m⍳1
                  :EndIf
              :EndTrap
          :EndIf
      :Until ('BlockLast'≡3⊃z)∨(length≤⍴resp)∨∨/'</soap:Envelope>'⍷resp   ⍝ Until error or all data received
     
      {}DRC.Close cmd
     
      :If DEBUG bit 1 ⋄ LastCallResponse←resp ⋄ :EndIf
     
      http←HTTPUtils.ParseHTTPResponse resp ⍝ build http struct and split off body
      :If 200≠http.StatusCode
          r←3((http.(StatusCode Reason)),⊂resp) ⍝ flag HTTP error
          :GoTo exit
      :EndIf
      r←SOAP.DecodeResponse http.MessageBody ⍝ if no error
      r[1]←(0 1 ¯1,r[1])[1 0 ¯1⍳r[1]] ⍝ adjust result to return 0 for no error
     exit:
    ∇

    ∇ r←host DefineService arg;service;page;mask;ref;api;ns;expfns;pvm;wsdl;svcname;port;url
                     ⍝ Builds the web service definition
                     ⍝ host - host name and port, used to get the port for the service
                     ⍝
                     ⍝ arg[1] - page name for the service
                     ⍝ arg[2] - Service (namespace name or reference to namespace containing the service)
                     ⍝ If arg[2]≡'', we search for a namespace matching the supplied page name
                     ⍝ arg[3] - root URL for the service (in the form 'HTTP{S}://...')
                     ⍝
                     ⍝ r[1] - return code (0-success, 1-failure)
                     ⍝ r[2] - service definition (success), or '' (failure)
                     ⍝        [1] API
                     ⍝        [2] ExportedFns
                     ⍝        [3] ServiceName
                     ⍝        [4] WSDL
                     ⍝        [5] namespace
      page service url←arg
      :If 'http'≢HTTPUtils.lc 4↑url ⋄ url←'http://',url ⋄ :EndIf
      :If 0∊⍴host ⋄ port←'80'  ⍝ default to port 80 (HTTP)
      :Else ⋄ port←1↓(∨\':'=host)/host ⍝ otherwise try to extract port
          :If 0∊⍴port ⋄ port←'80' ⍝ if no port specificed, default to port 80 (HTTP)
          :EndIf
      :EndIf
     
      r←1 '' ⍝ initialize result
     
      :If ~0∊⍴service ⍝ if service namespace name supplied
          ns←service ⍝ use it
      :Else
          ns←MatchNamespace page ⍝ otherwise, try to find namespace matching the page name
      :EndIf
     
      :If ~0∊⍴ns
          mask←'API' 'ExportedFns' 'ServiceName' 'WSDL' 'BuildAPI'∊(ref←⍎ns).⎕NL ¯2 ¯3
          :If ∧/4↑mask ⍝ are all components defined?
              r←0((ref.(API ExportedFns ServiceName WSDL)),⊂ns)  ⍝ use them
          :ElseIf mask[5] ⍝ do we have BuildAPI?
              svcname←ns~'#' ⋄ ((svcname='.')/svcname)←'/' ⋄ svcname←('/'=⍬⍴svcname)↓svcname
              api←ref.BuildAPI
              expfns←2⊃¨,¨1⊃¨api ⍝ exported functions based on the API
              pvm←0 2⍴⊂''
              pvm←pvm⍪'name'svcname
              pvm←pvm⍪'serviceURL'(url,':',port,'/',svcname,'/') ⍝ where the SOAP method calls are actually sent to
              pvm←pvm⍪'wsdlURL'(url,':',port,'/',svcname,'?WSDL/') ⍝ location of the WSDL XML document
              wsdl←SOAP.PrepareWSDL api pvm ⍝ build the WSDL
              r←0(api expfns svcname wsdl ns)
          :EndIf
      :EndIf
    ∇

    ∇ R←HandleRequest(cmd session);method;arg;ok;type;res;status;hdr;mpvm;TIME;buffer;name;ns;api;wsdl;expfns;WSDL;ServiceName;ExportedFns;API;rc;svc;ServiceNS;host
               ⍝ Web Service handler build for embedding in the Conga sample Web Server
               ⍝ Return HTTP return code, HTTP headers, HTTP body
               ⍝ buffer is ignored, entire input expected to be in "cmd"
     
      buffer←session.Buffer
      :If DEBUG bit 1 ⋄ LastRunRequest←buffer ⋄ :EndIf
      :If TRACE bit 0
          1 Output'>>> SAWS.HandleRequest <<<'
          1 Output'Command: ',terse(cmd.Command~⎕UCS 10)
          1 Output'Page:    ',terse(cmd.Page~⎕UCS 10)
          1 Output'buffer:  ',terse(buffer~⎕UCS 10)
          TIME←⎕AI[2]
      :EndIf
     
      host←cmd.Headers HTTPUtils.GetValue('host' '') ⍝ get the host name
      rc svc←host DefineService cmd.Page Service URL ⍝ build the service definition (Service and URL are defined in SAWS.Run)
     
      :If 0≠rc ⍝ failed to define service?
          type←¯1 ⋄ res←'Service.Invalid' 'The Web Service definition is not valid'
          status←'500 Internal Server Error'
          res←type SOAP.EncodeResponse res
          hdr←'content-type: text/xml'
      :Else
          API ExportedFns ServiceName WSDL ServiceNS←svc
          name←HTTPUtils.lc ServiceName
     
          :If ('get /',name,'?wsdl')≡(10+⍴name)↑cmd.Input ⋄ :AndIf ' /'∨.=1↑(10+⍴name)↓cmd.Input ⍝ Display WSDL?
              res←WSDL ⋄ status←'200 OK'
              hdr←'content-type: text/xml'
          :ElseIf ('get /',name)≡(5+⍴name)↑cmd.Input
          :OrIf (('post /',name,'/')≡(7+⍴name)↑cmd.Input)∧~(⊂'soapaction')∊cmd.Headers[;1]
              res status←ServiceHTML(cmd buffer)
              hdr←'content-type: text/html'
          :Else
                   ⍝ Since our WSDL (based on our API) says to use 'document/literal', no
                   ⍝ datatyping will be passed in the SOAP, so we need to pass the global API
                   ⍝ in order to describe to DecodeRequest how to datatypize everything.
              (ok res)←API SOAP.DecodeRequest buffer
     
              :If ok ⍝ success in decoding?
                  (method arg mpvm)←res
     
                  :If (⊂method)∊ExportedFns           ⍝ Is the call allowed?
                      :Trap (~DEBUG bit 0)/0
                          (type res)←⍎ServiceNS,'.',method,' arg'
                          :If type≠¯1 ⋄ res←method res mpvm ⋄ :EndIf
                      :Else
                          res←'Server.Unexpected' 'The Web Service generated an unexpected error.'(¯2↓∊⎕DM,¨⊂NL)
                          type←¯1
                      :EndTrap
                  :Else                               ⍝ Not in list of allowed methods
                      res←'Client.Permission' 'The method call is not allowed.'method
                      type←¯1
                  :EndIf
     
              :Else ⍝ bad request
                  type←¯1
              :EndIf
     
              status←(1+type≠¯1)⊃'500 Internal Server Error' '200 OK'
              res←type SOAP.EncodeResponse res
              hdr←'content-type: text/xml'
          :EndIf
      :EndIf
      R←status hdr res
    ∇

    ∇ {r}←{a}Init w
    ⍝ Initialize SAWS
    ⍝ w - dummy for consistency with Conga, SQAPL, etc
    ⍝ a - 1=hard initialization, 0=soft initialization
      a←{0::⍵ ⋄ a}1
      :If a=1
          ⎕TKILL ⎕TNUMS     ⍝ Kill any existing threads
          r←¯1 DRC.Init'' ⍝ Initialize CONGA
      :EndIf
      URL←Service←LastCallRequest←LastCallResponse←AltResponse←AltRequest←LastRunRequest←LastRunResponse←''
    ∇

    ∇ r←IsSecure cert;IsCert;ind;⎕ML
          ⍝ tests if cert contains a valid certificate
      ⎕ML←1
      r←{0::0
          (⎕CLASS DRC.X509Cert)≢⎕CLASS ⍵:0
          0≠⍵.IsCert}cert
    ∇

    ∇ r←MatchNamespace page;db;ind;chunk;nss;mask;nsslc;⎕IO;⎕ML;fns;root
               ⍝ Finds namespace matching the page name for the web service
               ⍝ Will find nested namespaces (e.g. /webservices/service1 maps to #.WebServices.Service1)
               ⍝ Note: Because page names are case insensitive we treat namespaces as case insensitive (#.Foo ≡ #.foo)
               ⍝  page - page (service name) possibly with a method name as well (/WebServices/Service1/Method1)
               ⍝  root - the root to search from
               ⍝  r - namespace name where the service is defined, or '' if not found
               ⍝
      ⎕ML ⎕IO←1
      page←HTTPUtils.lc page
      db←{(+/∧\' '=⍵)↓⍵}
      page←⌽db⌽db page ⍝ remove any leading or trailing blanks
      ((page='/')/page)←'.' ⍝ replace '/' with '.'
      r←''
      root←'#'⍝ start with root namespace
      :While ~0∊⍴page
          page←('.'=⍬⍴page)↓page ⍝ drop off leading '.'
          chunk←(¯1+ind←page⍳'.')↑page ⍝ grab
          nsslc←HTTPUtils.lc¨nss←(⍎root).⎕NL ¯9.1 ⍝
          mask←nsslc≡¨⊂chunk
          :Select +/mask
          :Case 0 ⍝ namespace not found, could be a method name
              :If '.'∊ind↓page ⋄ :Return
              :Else ⋄ r←root ⋄ :Return
              :EndIf
          :Case 1 ⍝ 1 namespace found
              root,←'.',⊃mask/nss
              page←ind↓page
          :Else ⍝ more than 1 namespace found (i.e. #.FOO and #.foo)
              :Return
          :EndSelect
      :EndWhile
      r←root
    ∇

    ∇ r←NL ⍝ return newline (CRLF)
      r←⎕UCS 13 10
    ∇

    ∇ {trace}Output msg
             ⍝ Simple output function, all output to the session should be funneled through here
      :If SILENT≤{0::0 ⋄ ⍎⍵}'trace'
          ⎕←msg
      :EndIf
    ∇

    ∇ r←ParseHTTP stream;ind;http;body;httpstruct
              ⍝ parses an HTTP message
              ⍝
      ind←¯1+((NL,NL)⍷stream)⍳1
      http←(ind⌊⍴stream)↑stream
      httpstruct←⎕NS''
      body←(4+ind)↓stream
    ∇

    ∇ r←request ResolveNamespaces response;xmlresp;nsdefs;nsrefs;refs;ancinds;i;defs;found;⎕ML;xmlreq;reqdefs;missing;mask;hit;updated
               ⍝ resolves any missing namespace references in the response
      ⎕ML←1
      nsdefs←{⍵{⍵/6↓⍺}'xmlns:'≡6↑⍵} ⍝ namespace definitions
      nsrefs←{{((':'∊⍵)∧'xmlns:'≢6↑⍵)/(∧\':'≠⍵)/⍵}(∧\'='≠⍵)/⍵}
      xmlresp←⎕XML response
      ancinds←ancestors xmlresp[;1]
      defs←nsdefs¨¨1⌷[2]¨xmlresp[;4]
               ⍝ find any unresolved namespace references
      refs←((⊂¨nsrefs¨xmlresp[;2]),¨nsrefs¨¨1⌷[2]¨xmlresp[;4])~¨⊂⊂''
      updated←0
      :For i :In ⍳⊃⍴xmlresp
          :If 0∊found←(i⊃refs)∊⊃,/(i⊃ancinds)⊃¨⊂defs ⍝ any unresolved?
              :If 0=⎕NC'xmlreq'
                  xmlreq←⎕XML request
                  reqdefs←nsdefs¨¨1⌷[2]¨xmlreq[;4]
              :EndIf
              :For missing :In (~found)/i⊃refs
                  mask←missing∊¨¨reqdefs  ⍝ this is dangerous, should match up tags
                  :Select +/hit←1∊¨mask
                  :Case 0 ⍝ not found, just skip it and hope
                  :Case 1 ⍝ got a match, add the namespace reference to the Envelope element
                      xmlresp[1;4]←⊂((⊂1 4)⊃xmlresp)⍪(⊃hit/mask)⌿⊃hit⌿xmlreq[;4]
                      refs←((⊂¨nsrefs¨xmlresp[;2]),¨nsrefs¨¨1⌷[2]¨xmlresp[;4])~¨⊂⊂''
                      updated←1
                  :Else ⍝ got more than one match, ambiguousness!
                      'Ambiguous namespace reference'⎕SIGNAL 701
                  :EndSelect
              :EndFor
          :EndIf
      :EndFor
      :If updated
          r←('whitespace' 'preserve'⎕XML xmlresp)~NL
      :Else
          r←response
      :EndIf
    ∇

    ∇ {r}←{svc}Run arg;thread;srvname;port
               ⍝ Run a Web Service using the Conga Demo WebServer
               ⍝ svc - name of or reference to the namespace containing the service definition
               ⍝ arg[1] - port to run on (default 8080)
               ⍝ arg[2] - run in a separate thread? (default 0)
               ⍝ arg[3] - server name (default 'HTTPSRV')
               ⍝ arg[4] - url for host (default 'localhost')
               ⍝
               ⍝ If Service is supplied, the server runs only that Web Service with the supplied port and server name
               ⍝ Note: Multiple Web Services can be run simultaneously provided that each one is run in a separate thread
               ⍝       and has a separate port and server name
               ⍝
               ⍝ If Service is not supplied, SAWS searchs for a namespace corresponding to the Web Service name
               ⍝ effectively allowing multiple Web Services to be run from a single server
               ⍝
      {}DRC.Init''
      ⎕EX'STOP' ⍝ remove STOP flag
      port thread srvname URL←4↑arg,(⍴,arg)↓8080 0 'HTTPSRV' 'localhost'
      :If 0∊⍴srvname ⋄ srvname←'HTTPSRV' ⋄ :EndIf
      :If 0∊⍴URL ⋄ URL←'localhost' ⋄ :EndIf
      :If 0=⎕NC'svc' ⋄ Service←''
      :Else ⋄ Service←⍕svc
      :EndIf
      :If thread
          r←WebServer.Run&'##.HandleRequest'port srvname
      :Else
          r←WebServer.Run'##.HandleRequest'port srvname
      :EndIf
    ∇

    ∇ {r}←{svc}RunSecure arg;thread;srvname;port;certpath;cert
               ⍝ Run a Secure Web Service using the Conga WebServer
               ⍝ svc - name of or reference to the namespace containing the service definition
               ⍝ arg[1] - port to run on (default 8080)
               ⍝ arg[2] - run in a separate thread? (default 0)
               ⍝ arg[3] - server name (default 'HTTPSRV')
               ⍝ arg[4] - root URL for service
               ⍝ arg[5] - path for certificates
               ⍝ arg[6] - server certificate (DRC.X509Cert instance) or empty/non-existent if not using certificate
               ⍝
               ⍝ If Service is supplied, the server runs only that Web Service with the supplied port and server name
               ⍝ Note: Multiple Web Services can be run simultaneously provided that each one is run in a separate thread
               ⍝       and has a separate port and server name
               ⍝
               ⍝ If Service is not supplied, SAWS searchs for a namespace corresponding to the Web Service name
               ⍝ effectively allowing multiple Web Services to be run from a single server
               ⍝
      {}DRC.Init''
      ⎕EX'STOP' ⍝ remove STOP flag
      port thread srvname URL certpath cert←6↑arg,(⍴,arg)↓445 0 'HTTPSRV' 'localhost' ''(⎕NEW DRC.X509Cert)
      :If 0∊⍴srvname ⋄ srvname←'HTTPSRV' ⋄ :EndIf
      :If 0∊⍴URL ⋄ URL←'localhost' ⋄ :EndIf
      :If 0=⎕NC'svc' ⋄ Service←''
      :Else ⋄ Service←⍕svc
      :EndIf
      :If thread
          r←certpath WebServer.HttpsRun&'##.HandleRequest'port srvname cert
      :Else
          r←certpath WebServer.HttpsRun'##.HandleRequest'port srvname cert
      :EndIf
    ∇

    ∇ (res status)←ServiceHTML(cmd buffer);⎕IO;method;post;inmls;intxt;innames;outmls;outtxt;outnames;i;dec;replace;f;name;lcname;len;svc;svcmls;ind;ismls
                    ⍝ simple HTML interface for methods
      ⎕IO←1
      replace←{ ⍝ inefficent but functional replacement function
          ⎕IO←1 ⋄ ⍺←'' ⋄ txt start end←,¨⍵
          0=⍴txt:⍺
          s←⍴start
          start≢s↑txt:(⍺,1↑txt)∇(1↓txt)start end
          n←{⍬≡0⍴⍵:⍵ ⋄ s+(s↓txt)⍳⍵}end
          (⍺,⍺⍺(n↑txt))∇(n↓txt)start end
      }
      dec←{  ⍝ hex string → integer
          ⎕ML ⎕IO←0
          16⊥16|'0123456789abcdef0123456789ABCDEF'⍳⍵
      }
      len←⍴lcname←HTTPUtils.lc ServiceName
     
      :If ('post /',lcname)≡(6+len)↑cmd.Input
          method←{(∧\⍵≠' ')/⍵}(7+len)↓cmd.Input
          post←1
      :ElseIf ('get /',lcname)≡(5+len)↑cmd.Input
          method←{(∧\⍵≠' ')/⍵}{('/'=1↑⍵)↓⍵}(5+len)↓cmd.Input
          :If (⍴method)≥i←method⍳'?' ⍝ parameters passed in URL?
              buffer←i↓method ⍝ if so, make it look like a post operation
              method←(i-1)↑method
              post←1
          :Else
              post←0
          :EndIf
      :Else
          :GoTo NOTFOUND
      :EndIf
     
      :If method∧.=' ' ⍝ No method named
          res←'<html><head>',(1⊃,,/STYLE,¨⊂NL),'<title>',ServiceName,'</title></head>'
          res,←'<body>'
          res,←'<div id="content"><p class="heading1">',ServiceName,'</p><br/>'
          res,←'<p class="intro">The following operations are supported.  For a formal definition, please review the <a href="../',ServiceName,'?WSDL" target="_blank">Service Description</a>. </p>'
          res,←'<ul>'
          :For f :In ExportedFns
              res,←'<li><a href="/',ServiceName,'/',f,'">',f,'</a></li>'
          :EndFor
          res,←'</ul></div></body></html>'
          status←'200 OK'
          :Return
      :EndIf
     
      :If (1+⍴API)=i←(HTTPUtils.lc¨ExportedFns)⍳⊂method
          :GoTo NOTFOUND
      :EndIf
      method←i⊃ExportedFns
     
      svc inmls outmls←(i⊃API)      ⍝ the API give MLS input and output
                    ⍝⍝ we just need to fill the value fields now
      svcmls←4⊃,svc
      :If post
                        ⍝ Get values from a POST operation on the generated HTML page.
                        ⍝ It relies on the order of the html inputs to be the same as the API description.
                        ⍝ PS : the last one is the submit button, ignore it.
                        ⍝ Syntax of buffer : name1=value1&name2=value2&...
          intxt←(↑⍴inmls)↑{(⍵⍳'=')↓⍵}¨{(⍵≠'&')⊂⍵}buffer
                        ⍝ replace '+' by '%20'
          intxt←{{'%20'}replace ⍵'+' 1}¨intxt
                        ⍝ decode percent-encoded values
          intxt←{{⎕UCS dec 2↑1↓⍵}replace ⍵'%' 3}¨intxt
                        ⍝ decode unicode characters, but only for input to function
                        ⍝ the html text will keep the &#NNNN; pattern
          inmls[;3]←{{⎕IO←1 ⋄ ⎕UCS 2⊃⎕VFI 2↓¯1↓⍵}replace ⍵'&#' ';'}¨intxt
     
          inmls←2⊃inmls #.SAWS.SOAP.SOAP2Data inmls
     
          :Trap (~DEBUG bit 0)/0         ⍝ Are we in debug mode?
              (ismls outmls)←⍎ServiceNS,'.',method,' inmls'
          :Else
              res←'The Web Service generated an unexpected error:',NL,(¯2↓∊⎕DM,¨⊂NL)
              :GoTo ERROR
          :EndTrap
     
          :If ismls=¯1
              res←,⍕outmls
              :GoTo ERROR
          :ElseIf 0=ismls ⍝ if the result is not an MLS (meaning it's APL data), fake it for the HTTP interface
              outmls←1 4⍴1 'Result'outmls(0 2⍴⊂'')
          :EndIf
      :Else
                        ⍝ default input value
          intxt←inmls[;3]
      :EndIf
      outtxt←,∘⍕¨outmls[;3]
     
                    ⍝ replace unicode with HTML pattern &#NNNN;
      outtxt←{{128>⎕UCS ⍵:⍵ ⋄ '&#',(⍕⎕UCS ⍵),';'}replace ⍵'' 1}¨outtxt
                    ⍝ replace newlines with <br/>
      outtxt←{{'<br/>'}replace ⍵ NL(⍴NL)}¨outtxt
     
      res←'<html><head>',(1⊃,,/STYLE,¨⊂NL),'<title>',ServiceName,': ',method,'</title></head>'
      res,←'<body>'
      res,←'<div id="content"><p class="heading1">',ServiceName,': ',method,'</p><br/>'
      :If (⍬⍴⍴svcmls)≥ind←svcmls[;1]⍳⊂'documentation'
          res,←'<h3>',method,': ',((⊂ind,2)⊃svcmls),'</h3>'
      :EndIf
      res,←'<p><form name="saws_',method,'_form" method="post" action="',method,'">'
     
      innames outnames←(inmls[;2])(outmls[;2]) ⍝ names of variables
     
      :If ~0∊⍴innames
          res,←'<p class="intro">Please enter the input parameter',(1=⍬⍴⍴innames)↓'s for the ',method,' method:</p>'
          res,←'<table>'
          res,←↑,/innames{'<tr><td>',⍺,'</td><td><input type="text" name="',⍺,'" value="',⍵,'"> </td></tr>'}¨intxt
          res,←'</table>'
      :EndIf
     
      res,←'<p> <input type="submit" name="Submit" value="Submit"> </p>'
     
      :If post ⍝ We should have results?
          res,←'<table border=1>'
          :If 0∊⍴outnames
              res,←'<tr><td>No Result</td></tr>'
          :Else
              res,←↑,/outnames{'<tr><td>',⍺,'</td><td>',⍵,'</td></tr>'}¨outtxt
          :EndIf
          res,←'</table>'
      :EndIf
     
      res,←'</form>'
      res,←'<p><a href="/',ServiceName,'">Return to main page</a></p>',NL
      res,←'</body></div></html>'
      status←'200 OK'
      :Return
     
     ERROR:
      status←'500 Internal Server Error'
      :Return
     
     NOTFOUND:
      status←'404 Not Found'
      res←'Error 404 : page not found.'
      :Return
    ∇

    ∇ {r}←Stop srvname
                ⍝ Stop the Web Service server
                ⍝ srvname - name of the server to stop (defaults to 'HTTPSRV' if srvname≡'')
                ⍝ r[1] - 0 (success), otherwise error code
                ⍝ r[2] - error name if r[1]≠0
                ⍝ r[3] - error description if r[1]≠0
      :If 0∊⍴srvname ⋄ r←DRC.Close¨DRC.Names'.'
      :Else ⋄ r←DRC.Close srvname
      :EndIf
    ∇

    ∇ {address}Test close;Start;i;n;Time;r;port
               ⍝ Start Web Service and make some calls to it
               ⍝ address - web server address (defaults to 'localhost')
               ⍝ close - =0 just start Web Service, =1 run test, =¯1 service already started, just run test
     
      port←8080
      :If 0=⎕NC'address' ⋄ address←'localhost' ⋄ :EndIf
     
      :If close≠¯1
          Init
          #.MyWebService Run port 1 ⍝ Start Server
          ⎕DL 1           ⍝ Give it time to wake up
      :EndIf
     
      :If close=0
          Output'Server ''HTTPSRV'' still running... To stop it, type:' ⋄ ''
          Output'SAWS.Stop '''''
          →0
      :EndIf
     
      Output'Running'(n←100)'tests...'
      Start←3⊃⎕AI
     
      :For i :In ⍳n
          r←address port Call'MyWebService' 'Regression'('Data' '2 4 6 8.1' 'Degree' 1 'Factor' 1000)
      :EndFor
     
      Time←(3⊃⎕AI)-Start
      Output i'calls in'Time'msec ='(1⍕÷Time÷1000×n)'calls/sec'
      Output'Response:'r
     
      :If close=1 ⋄ Stop'' ⋄ :EndIf ⍝ Server should shut down
    ∇

    ∇ r←ancestors v;bv;i;inds;mask;plens;scope;where;⎕IO
      ⎕IO←1
      r←(⍴v)⍴⊂⍬
      where←{⍵/⍳⍴⍵}
      plens←{⍵{⍵-⍨1↓⍵,1+⍴⍺}(where ⍵)}
      :For i :In 0,⍳⌈/v
          mask←i=v
          scope←i<v
          bv←mask∨scope
          (bv/r)←(bv/r),¨(plens bv/mask)/where mask
      :EndFor
    ∇

      bit←{⎕IO←0
          0=⍺:0 ⍝ all bits turned off
          ¯1=⍺:1 ⍝ all bits turned on
          ⍵⊃⌽((1+⍵)⍴2)⊤⍺}

    terse←{(((65⌊⍴⍵)⌈(⍴⍵)×~TRACE bit 1)↑⍵),((65<⍴⍵)∧TRACE bit 1)/'...'}

    :Namespace HTTPUtils

        ⎕IO  ←0 ⍝ *** DO NOT change these system variables here, only after the variables definition

⍝ === VARIABLES ===

        HTTPStatusCodes←40 2⍴100 'Continue' 101 'Switching Protocols' 200 'OK' 201 'Created' 202 'Accepted' 203 'Non-Authoritative Information' 204 'No Content' 205 'Reset Content' 206 'Partial Content' 300 'Multiple Choices' 301 'Moved Permanently' 302 'Found' 303 'See Other' 304 'Not Modified' 305 'Use Proxy' 307 'Temporary Redirect' 400 'Bad Request' 401 'Unauthorized' 402 'Payment Required' 403 'Forbidden' 404 'Not Found' 405 'Method Not Allowed' 406 'Not Acceptable' 407 'Proxy Authorization Required' 408 'Request Timeout' 409 'Conflict' 410 'Gone' 411 'Length Required' 412 'Precondition Failed' 413 'Request Entity Too Large' 414 'Request-URI Too Long' 415 'Unsupported Media Type' 416 'Requested Range Not Satisfiable' 417 'Expectation Failed' 500 'Internal Server Area' 501 'Not Implemented' 502 'Bad Gateway' 503 'Service Unavailable' 504 'Gateway Timeout' 505 'HTTP Version Not Supported'

        NL←⎕av[3 2]


⍝ === End of variables definition ===

        ⎕IO ⎕ML ⎕WX←1 0 3

        ∇ HTTPCmd←DecodeCmd req;buf;input;args;z
               ⍝ Decode an HTTP command line: get /page&arg1=x&arg2=y
               ⍝ Return namespace containing:
               ⍝ Command: HTTP Command ('get' or 'post')
               ⍝ Headers: HTTP Headers as 2 column matrix or name/value pairs
               ⍝ Page:    Requested page
               ⍝ Arguments: Arguments to the command (cmd?arg1=value1&arg2=value2) as 2 column matrix of name/value pairs
         
          input←1⊃,req←2⊃##.HTTPUtils.DecodeHeader req
          'HTTPCmd'⎕NS'' ⍝ Make empty namespace
          HTTPCmd.Input←input
          HTTPCmd.Headers←{(0≠⊃∘⍴¨⍵[;1])⌿⍵}1 0↓req
          HTTPCmd.Command buf←' 'split input
          buf z←'http/'split buf
          HTTPCmd.Page args←'?'split buf
          HTTPCmd.Arguments←(args∨.≠' ')⌿↑'='∘split¨{1↓¨(⍵='&')⊂⍵}'&',args ⍝ Cut on '&'
        ∇

        ∇ r←DecodeHeader buf;len;d
               ⍝ Decode HTML Header
         
          len←(¯1+⍴NL,NL)+⊃{((NL,NL)⍷⍵)/⍳⍴⍵}buf
          :If len>0
              d←(⍴NL)↓¨{(NL⍷⍵)⊂⍵}NL,len↑buf
              d←↑':'∘split¨d
              d[;1]←lc¨d[;1]
          :Else
              d←⍬
          :EndIf
          r←len d
        ∇

        ∇ code←Encode strg;raw;rows;cols;mat;alph
               ⍝ Base64 Encode
          raw←⊃,/11∘⎕DR¨strg
          cols←6
          rows←⌈(⊃⍴raw)÷cols
          mat←rows cols⍴(rows×cols)↑raw
          alph←'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
          alph,←'abcdefghijklmnopqrstuvwxyz'
          alph,←'0123456789+/'
          code←alph[⎕IO+2⊥⍉mat],(4|-rows)⍴'='
        ∇

        ∇ r←header GetValue(name type);i;h
               ⍝ Extract value from HTTP Header structure returned by DecodeHeader
         
          :If (1↑⍴header)<i←header[;1]⍳⊂lc name
              r←⍬ ⍝ Not found
          :Else
              r←⊃header[i;2]
              :If 'Numeric'≡type
                  r←1⊃2⊃⎕VFI r
              :EndIf
          :EndIf
        ∇

        ∇ r←port HostPort host;z
               ⍝ Split host from port
         
          :If (⍴host)≥z←host⍳':'
              port←1⊃2⊃⎕VFI z↓host ⋄ host←(z-1)↑host  ⍝ Use :port if found in host name
          :EndIf
         
          r←host port
        ∇

        ∇ HTTPResponse←ParseHTTPResponse resp;status;rest;tmp;version;reason;code;headers;body
               ⍝ Parses an HTTP response
               ⍝ resp is a character vector HTTP response
          status rest←NL split resp
          version tmp←' 'split status
          code reason←' 'split tmp
          headers body←(NL,NL)split rest
          headers←headers spliton NL
          headers←↑':'∘split¨headers
          headers[;1]←lc¨headers[;1]
          'HTTPResponse'⎕NS''
          HTTPResponse.HTTPVersion←version
          HTTPResponse.StatusCode←⊃(//)⎕VFI code
          HTTPResponse.Reason←reason
          HTTPResponse.Headers←headers
          HTTPResponse.MessageBody←body
        ∇

        ∇ r←{options}Table data;NL
               ⍝ Format an HTML Table
         
          NL←⎕AV[4 3]
          :If 0=⎕NC'options' ⋄ options←'' ⋄ :EndIf
         
          r←,∘⍕¨data                     ⍝ make strings
          r←,/(⊂'<td>'),¨r,¨⊂'</td>'     ⍝ enclose cells to make rows
          r←⊃,/(⊂'<tr>'),¨r,¨⊂'</tr>',NL ⍝ enclose table rows
          r←'<table ',options,'>',r,'</table>'
        ∇

        ∇ r←lc x;t
          t←⎕AV ⋄ t[⎕AV⍳⎕A]←'abcdefghijklmnopqrstuvwxyz'
          r←t[⎕AV⍳x]
        ∇

        split←{p←(⍺⍷⍵)⍳1 ⋄ ((p-1)↑⍵)((p+(⍴,⍺)-⎕IO)↓⍵)}

        spliton←{⎕ML←0 ⋄ b←m←⍵⍷⍺ ⋄ b[⎕IO]←1 ⋄ ((b/m)×⍴,⍵)↓¨b⊂⍺}

    :EndNamespace
    :Namespace SOAP
        ⎕IO ⎕ML ⎕WX←1 3 3

        ∇ R←pvm API2WSDL api;A;B;D;epvm;I;J;K;max;method;min;mpvm;name;request;response;rmls;rpvm;serviceURL;type;typesURL;wsdlURL;props;doc;mname;pattern;d
                      ⍝ Transform an "API" into a WSDL-MLS
                      ⍝ -----------------------------------------------------------------------------------
                      ⍝ SYNTAX:   R←API2WSDL api
                      ⍝
                      ⍝ DESCRIPTION:
                      ⍝  This is just a simple WSDL generator, given a simple API.
                      ⍝  It is NOT intended to accommodate some very general case of data descriptions
                      ⍝  involving domains, constraints, shapes, etc.
                      ⍝  It is involved only with basic structure (what you will see as described by
                      ⍝  columns 1 and 2 in the MLS) and also with datatypes.
                      ⍝
                      ⍝ ARGS/RESULT:
                      ⍝  api      - Application Programming Interface, described by a vector of method descriptions.
                      ⍝             EACH ELEMENT in this vector is 3 elements and each is defined as follows:
                      ⍝              [1] - method info. This is typically just the name of the method.
                      ⍝                    However, it may also be a 1-row MLS, e.g. 1 'MyMethod' '' PVM,
                      ⍝                    where the PVM element more fully specifies the method's nature.
                      ⍝                     ∘ 'pattern' - 1 - One-way  (input)
                      ⍝                                   2 - Request-response (input-output)
                      ⍝                                   3 - Solicit-response (output-input) - [NOT IMPLEMENTED YET]
                      ⍝                                   4 - Notification (output)
                      ⍝                        If the 'pattern' property is not specified, the nature of the method
                      ⍝                        will be determined based on elements 2 and 3 below as so:
                      ⍝                          [2]-non-empty, [3]-empty     ==> 'pattern' is assumed to 1
                      ⍝                          [2]-non-empty, [3]-non-empty ==> 'pattern' is assumed to 2
                      ⍝                          [2]-empty,     [3]-non-empty ==> 'pattern' is assumed to 4
                      ⍝                        To show that your method adheres to a 'pattern' of 3, the 'pattern'
                      ⍝                        has to be set to 3 in the PVM.
                      ⍝                     ∘ 'documentation' - charvec of associated documentation
                      ⍝              [2] - argument/request description, as an MLS
                      ⍝              [3] - result/response description, as an MLS
                      ⍝             Each MLS (those in elements 2 and 3 above) describes the allowable structure
                      ⍝             of the data (intended as the argument or result). It is a sort of model
                      ⍝             or prototype along with a few attributes to more fully describe it.
                      ⍝             So, the 1st and 2nd columns of the MLS look much like the real data would.
                      ⍝             The 3rd column, the content, is empty for now (perhaps it will be used
                      ⍝             later for something in the future, e.g. example data).
                      ⍝             The 4th column consists of PVMs where the following attributes are utilized:
                      ⍝              'datatype' - it can be one of the following: 'string' 'boolean' 'integer' 'double'
                      ⍝                           Default: '' ==> container element
                      ⍝                           It may also be a datatype defined by http://www.w3.org/TR/xmlschema-2/;
                      ⍝                           to specifically use one of those, use the "xsd:" prefix, e.g. 'xsd:dateTime'
                      ⍝                           Note: The datatypes listed above actually do correspond (same names exactly)
                      ⍝                                 with real xsd datatypes. However, it is intended that you are
                      ⍝                                 able to pass generic datatypes and these would get mapped
                      ⍝                                 to the appropriate ones should they ever vary from WSDL schema.
                      ⍝              'minimum'  - the minimum number of times that this element must occur, PER PARENT. Default: 0
                      ⍝              'maximum'  - the maximum number of times that this element must occur, PER PARENT. Default: ∆MV ==> unlimited
                      ⍝              'documentation' - charvec of associated documentation
                      ⍝              Note that minimum and maximum are not describing the minimum/maximum value
                      ⍝              of the content; they are describing the structure of the elements. They
                      ⍝              are commonly used for showing whether some element is single or multiple
                      ⍝              but they can be further utilized to describe requiredness or a maximum
                      ⍝              count of some element at some level.
                      ⍝              The following describes a single required element: ⊃('minimum' 1)('maximum' 1).
                      ⍝              The following describes an optional array of elements, of any length: 1 2⍴'minimum' 0
                      ⍝  pvm      - PVM containing the primary information about the Web Service
                      ⍝               name       - name of the Web Service
                      ⍝               serviceURL - URL/address of the Web Service. This is where the SOAP-XML
                      ⍝                            methods/requests are actually sent to.
                      ⍝               wsdlURL    - associated WSDL URL. This should be the URL of where to retrieve
                      ⍝                            the complete WSDL document, as XML (what this function is
                      ⍝                            generating the MLS for)
                      ⍝                            Default: <serviceURL>,'/wsdl'
                      ⍝  R        - an MLS that describes a formal WSDL, consisting of all of the methods.
                      ⍝             Running this through MLS2XML generates a WSDL document that is
                      ⍝             suitable for using in a Web Service.
                      ⍝
                      ⍝ EXAMPLE:
                      ⍝   api←0⍴⊂'' ⍝ initialize the right argument to API2WSDL
                      ⍝  ⍝ Describe the method for updating information on several people in one call.
                      ⍝   method←'UpdatePersons'
                      ⍝   arg←0 4⍴0
                      ⍝   arg←arg⍪1 'person'       '' (1 2⍴                     'minimum' 0)
                      ⍝   arg←arg⍪2   'lastname'   '' (⊃('datatype' 'string')  ('minimum' 1)('maximum' 1))
                      ⍝   arg←arg⍪2   'firstname'  '' (⊃('datatype' 'string')  ('minimum' 1)('maximum' 1))
                      ⍝   arg←arg⍪2   'dob'        '' (⊃('datatype' 'xsd:date')('minimum' 1)('maximum' 1))
                      ⍝   arg←arg⍪2   'phones'     '' (⊃                       ('minimum' 0)('maximum' 3))
                      ⍝   arg←arg⍪3     'phonenum' '' (⊃('datatype' 'string')  ('minimum' 1)('maximum' 1))
                      ⍝   arg←arg⍪3     'type'     '' (⊃('datatype' 'integer') ('minimum' 0)('maximum' 1))
                      ⍝   result←0 4⍴0
                      ⍝   result←result⍪1 'success' '' (⊃'datatype' 'boolean') ('minimum' 1)('maximum' 1))
                      ⍝   api←api,⊂method arg result
                      ⍝  ⍝ Describe the method for ...
                      ⍝   method←'...'
                      ⍝   arg←...
                      ⍝   result←...
                      ⍝   api←api,⊂method arg result
                      ⍝  ⍝ Describe the method for ...
                      ⍝   method←'...'
                      ⍝   arg←...
                      ⍝   result←...
                      ⍝   api←api,⊂method arg result
                      ⍝
                      ⍝   ... API2WSDL api ==>
                      ⍝
                      ⍝ SUBFNS:  ∆MV PVMGetVal PVMGetVals Parent
                      ⍝ -----------------------------------------------------------------------------------
          epvm←0 2⍴⊂''
         
          :If 0=⎕NC'pvm' ⋄ pvm←epvm ⋄ :EndIf
          serviceURL←'serviceURL' 'http://Unspecified/WebService/'PVMGetVal pvm
          serviceURL←serviceURL,('/'≠¯1↑serviceURL)/'/'
          props←''
          props←props,⊂'name' 'UnspecifiedWebService'
          props←props,⊂'wsdlURL'(serviceURL,'wsdl/')
          (name wsdlURL)←props PVMGetVals pvm
          :If '/'≠¯1↑wsdlURL ⋄ wsdlURL←wsdlURL,'/' ⋄ :EndIf
          typesURL←serviceURL,'schema/'
         
                      ⍝ For each method-part, get the method's name, pattern, documentation.
          :For I :In ⍳⍴api
              method←I 1⊃api
              :If B←1<≡method
                  (mname mpvm)←method[1;2 4]
                  (pattern doc)←'pattern'('documentation' '')PVMGetVals mpvm
              :Else
                  mname←method
                  doc←''
              :EndIf
              :If ~B ⋄ :OrIf pattern≡∆MV
                  pattern←(1 2 4)[(1 0)(1 1)(0 1)⍳⊂×↑¨⍴¨(I⊃api)[2 3]]
              :EndIf
              ((I 1)⊃api)←mname pattern doc
          :EndFor
         
          pvm←epvm
          pvm←pvm⍪'name'name
          pvm←pvm⍪'targetNamespace'wsdlURL
          pvm←pvm⍪'xmlns:tns'wsdlURL
          pvm←pvm⍪'xmlns:mytypes'typesURL
          pvm←pvm⍪'xmlns' 'http://schemas.xmlsoap.org/wsdl/'
          pvm←pvm⍪'xmlns:xsd' 'http://www.w3.org/2001/XMLSchema'
          pvm←pvm⍪'xmlns:soap' 'http://schemas.xmlsoap.org/wsdl/soap/'
          pvm←pvm⍪'xmlns:soapenc' 'http://schemas.xmlsoap.org/soap/encoding/'
          pvm←pvm⍪'xmlns:http' 'http://schemas.xmlsoap.org/wsdl/http/'
          pvm←pvm⍪'xmlns:mime' 'http://schemas.xmlsoap.org/wsdl/mime/'
         
          R←1 4⍴1 'definitions' ''pvm
         
                      ⍝ Types:
          R←R⍪2 'types' ''epvm
          R←R⍪3 'xsd:schema' ''(2 2⍴'targetNamespace'typesURL'elementFormDefault' 'qualified')
          :For I :In ⍳⍴api
              (method request response)←I⊃api
              mname←1⊃method
              :For J :In ⍳2
                  :If 0∊rmls←J⊃request response ⋄ :Continue ⋄ :EndIf
                  :If J=2 ⋄ mname←mname,'Response' ⋄ :EndIf
                  R←R⍪4 'xsd:element' ''(1 2⍴'name'mname)
                  R←R⍪5 'xsd:complexType' ''epvm
                  R←R⍪6 'xsd:sequence' ''epvm
         
                  rmls←0 '' ''epvm⍪rmls ⍝ (just so we can have a parent for the top-level nodes too because, in the general case, we have to look to the parent to see what depth we should start at)
                  D←(↑⍴rmls)⍴7 ⍝ starting depths
                  :For K :In 1↓⍳↑⍴rmls
                      d←D[K Parent rmls[;1]]
                      (type min max doc)←('datatype' '')('minimum' 0)('maximum' 'unbounded')('documentation' '')PVMGetVals((⊂K 4)⊃rmls)
                      rpvm←⊃('name'((⊂K 2)⊃rmls))('minOccurs'min)('maxOccurs'max)
                           ⍝:IF min=0 ⋄ rpvm←rpvm⍪'nillable' 'true' ⋄ :ENDIF ⍝ *** - ???
                      :If 0<⍴doc ⋄ doc←1 4⍴(d+1)'documentation'doc epvm ⋄ :Else ⋄ doc←0 4⍴0 ⋄ :EndIf
         
                      :If 0≠⍴type
                          :If ~':'∊type
                                   ⍝type←('string' 'boolean' 'integer' 'double'⍳⊂type)⊃'string' 'boolean' 'integer' 'double' ⍝ don't have to run this since the mapping is a noop
                              type←'xsd:',type
                          :EndIf
                          rpvm←rpvm⍪'type'type
                          R←R⍪(d'xsd:element' ''rpvm)⍪doc
                      :Else
                          R←R⍪(d'xsd:element' ''rpvm)⍪doc
                          R←R⍪⊃((d+1)'xsd:complexType' ''epvm)((d+2)'xsd:sequence' ''epvm)
                          D[K]←d+3
                      :EndIf
                  :EndFor
              :EndFor
          :EndFor
         
               ⍝ Messages:
          :For I :In ⍳⍴api
              (mname pattern)←2↑I 1⊃api
              :If pattern<4
                  R←R⍪2 'message' ''(1 2⍴'name'(mname,'MessageIn'))
                  R←R⍪3 'part' ''(2 2⍴'name' 'parameters' 'element'('mytypes:',mname)) ⍝ (we'll use 'parameters' as the name simply because that's what .NET uses)
              :EndIf
              :If pattern>1
                  R←R⍪2 'message' ''(1 2⍴'name'(mname,'MessageOut'))
                  R←R⍪3 'part' ''(2 2⍴'name' 'parameters' 'element'('mytypes:',mname,'Response'))
              :EndIf
          :EndFor
         
               ⍝ Operations:
          R←R⍪2 'portType' ''(1 2⍴'name'(name,'_PortType'))
          :For I :In ⍳⍴api
              (mname pattern doc)←I 1⊃api
              R←R⍪3 'operation' ''(1 2⍴'name'mname)
              :If 0<⍴doc
                  R←R⍪4 'documentation'doc epvm
              :EndIf
              :If pattern<4
                  R←R⍪4 'input' ''(1 2⍴'message'('tns:',mname,'MessageIn'))
              :EndIf
              :If pattern>1
                  R←R⍪4 'output' ''(1 2⍴'message'('tns:',mname,'MessageOut'))
              :EndIf
          :EndFor
         
               ⍝ Bindings:
          R←R⍪2 'binding' ''(2 2⍴'name'(name,'_Binding')'type'('tns:',name,'_PortType'))
          R←R⍪3 'soap:binding' ''(2 2⍴'style' 'document' 'transport' 'http://schemas.xmlsoap.org/soap/http')
               ⍝A←5 'soap:body' '' (3 2⍴'use' 'literal' 'encodingStyle' 'http://schemas.xmlsoap.org/soap/encoding/' 'namespace' ('urn:',name))
          A←5 'soap:body' ''(1 2⍴'use' 'literal') ⍝ for the "wrapped" convention, you are NOT supposed to include or 'encodingStyle' or 'namespace'
          :For I :In ⍳⍴api
              (mname pattern)←2↑I 1⊃api
              R←R⍪3 'operation' ''(1 2⍴'name'mname)
              R←R⍪4 'soap:operation' ''(1 2⍴'soapAction'mname)
              :If pattern<4
                  R←R⍪4 'input' ''epvm
                  R←R⍪A
              :EndIf
              :If pattern>1
                  R←R⍪4 'output' ''epvm
                  R←R⍪A
              :EndIf
          :EndFor
         
               ⍝ Service:
          R←R⍪2 'service' ''(1 2⍴'name'name)
          R←R⍪3 'port' ''(2 2⍴'name'(name,'_Port')'binding'('tns:',name,'_Binding'))
          R←R⍪4 'soap:address' ''(1 2⍴'location'serviceURL)
        ∇

        ∇ R←APL2SOAP rarg;tree;I;stypes;B;⍙mv;applyB;nullB;atomsB;inds;tags;inherit
               ⍝ Transform some arbitrary APL data into a SOAP-MLS
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←APL2SOAP rarg
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  rarg     - any APL data
               ⍝  R        - SOAP-MLS
               ⍝
               ⍝ SUBFNS:   ∆MV WHERE ⍙APL2SOAP_Recurse ConcatMats
               ⍝ -----------------------------------------------------------------------------------
         
          ⍙mv←∆MV ⍝ initialize for globals use
          tree←1 ⍙APL2SOAP_Recurse rarg ⍝ normalize the data, via recursion, to make it easy to transform hereafter
          atomsB←0≠tree[;4] ⍝ atoms (have data; they're not just containers)
          applyB←0<tree[;5] ⍝ need a datatype applied to them (not represented by their respective parent's datatype)
          nullB←¯1=tree[;5] ⍝ need special xsi:null="1" applied to them
          inherit←(applyB/⍳↑⍴tree)[+\applyB]
         
               ⍝ Initialize the result.
          R←((↑⍴tree),4)⍴'a' ⋄ R[;1 3]←tree[;1 2] ⋄ R[;4]←⊂0 2⍴⊂''
         
               ⍝ Map to the SOAP datatypes (be sure to use 'double', not 'float', since APL "float" is 64-bit, not 32-bit).
          stypes←(4⍴⊂'xsd:string'),(3⍴⊂'xsd:int'),'xsd:double' 'xsd:boolean' 'xsd:ur-type' 'SOAP-ENC:Array' '' ⍝ (the '' at the end is for tree[;5] being 0)
          stypes←stypes[inds←82 80 160 320 83 163 323 645 11 807 326⍳tree[;5]] ⍝ important: these now are either the datatype of self or, if a container, the datatype of the children
          tags←(4 3 1 1 1 1 1/'string' 'integer' 'double' 'boolean' 'ur-type' 'array' '')[inds[inherit]]
         
               ⍝ Plug in the appropriate PVM for atoms of basic datatypes.
          I←WHERE applyB∧atomsB
          R[I;4]←(⊂1 2)⍴¨⊂[2](⊂'xsi:type'),[1.5]stypes[I]
          I←WHERE atomsB
          R[I;2]←tags[I]
         
               ⍝ The containers have 2 attribute values:  xsi:type="SOAP-ENC:Array" SOAP-ENC:arrayType="xsd:DATATYPE[n,m...]"
          I←WHERE applyB>atomsB
          R[I;2]←⊂'array' ⍝ (this is just a convention, as is the child 'a' initialized in <R> up above)
          R[I;4]←(⊂1 2⍴'xsi:type' 'SOAP-ENC:Array')⍪¨⊂[2](⊂'SOAP-ENC:arrayType'),[1.5]stypes[I],¨'[',¨(1↓¨∊¨',',¨¨⍕¨¨tree[I;3]),¨']'
         
               ⍝ Plug in special attribute showing NULL (more rare so check for 1∊ up front)
          :If 1∊nullB
                   ⍝ Yes, this use of setting xsi:null="1" appears to be inconsistent.  Why not
                   ⍝ have 'xsd:null' up above with the other datatypes and then we wouldn't need to
                   ⍝ special case anything here? Regardless of that, it appears that we still do
                   ⍝ need xsd:null so that we can describe an array of nulls, e.g. 'xsi:null[2,3]'.
              I←WHERE nullB∧atomsB
              R[I;4]←⊂1 2⍴'xsi:null' 1
         
              I←WHERE nullB>atomsB
              R[I;4]←(⊂1 2⍴'xsi:type' 'SOAP-ENC:Array')⍪¨⊂[2](⊂'SOAP-ENC:arrayType'),[1.5](⊂'xsd:null'),¨'[',¨(1↓¨∊¨',',¨¨⍕¨¨tree[I;3]),¨']'
          :EndIf
         
               ⍝ ===================================================================================
               ⍝ We have to special case some types of APLish data.
               ⍝ SOAP considers character vectors to be at the atomic level. No shape needs to be
               ⍝ described for them. So, neither an APL character scalar nor a multi-dimensional
               ⍝ character array has a real analog in SOAP since you cannot describe its shape unless
               ⍝ you umbrella it with an 'array' tag which implies it is nested.
               ⍝ Essentially, we just can't have the SOAP 'array' element serve double-duty
               ⍝ (it can't serve the purpose of nestedness and an array-shape descriptor).
               ⍝ We'll have to add our own special property in order to overcome this.
               ⍝ This way, we will at least always ensure that the following is true for any data:
               ⍝  data≡SOAP2APL APL2SOAP data
          :If 1∊B←¯1=tree[;4]
              I←WHERE B
              R[I;3]←,¨R[I;3]
              R[I;4]←R[I;4]⍪¨⊂[2](⊂'APL-ENC:shape'),[1.5]⍕¨tree[I;3]
          :EndIf
        ∇

        ∇ R←I Ancestors dv
               ⍝ Return the indices of the ancestors for some specified index
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←I Ancestors dv
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  dv       - depth vector
               ⍝  I        - index to find the ancestors of
               ⍝  R        - indices of the ancestors, in ascending order
               ⍝ -----------------------------------------------------------------------------------
          dv←dv+1-⌊/dv ⍝ normalize
          R←I-(⌽(I-1)↑dv)⍳⍳dv[I]-1
        ∇

        ∇ R←depth BeginDepth R
               ⍝ Simple cover - begin the depth of an MLS with the value specified
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←depth BeginDepth mls
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  mls      - Markup Language Structure or any matrix where the first column is
               ⍝             a depth vector
               ⍝  depth    - integer depth to begin at
               ⍝  R        - adjusted MLS
               ⍝
               ⍝ EXAMPLE:
               ⍝  mls←0 4⍴''
               ⍝  mls←mls⍪3 'this'  ...
               ⍝  mls←mls⍪4 'that'  ...
               ⍝  mls←mls⍪5 'other' ...
               ⍝  mls←mls⍪4 'stuff' ...
               ⍝  mls←mls⍪4 'more'  ...
               ⍝  2 BeginDepth mls ==> 2 'this'  ...
               ⍝                       3 'that'  ...
               ⍝                       4 'other' ...
               ⍝                       3 'stuff' ...
               ⍝                       3 'more'  ...
               ⍝ -----------------------------------------------------------------------------------
          R[;⎕IO]←R[;⎕IO]-(↑R)-depth
        ∇

        BeginsWith←{⍵≡(⍴⍵)↑⍺}

        Children←{dv←⍵+1-⌊/⍵ ⋄ res←¯1+(dv[⍺]<D←⍺↓dv)⍳0 ⋄ ⍺+((res↑D)=dv[⍺]+1)/⍳res}

        ∇ R←ConcatMats rarg;I;numrows;rows;C;cols;B
               ⍝ Cover for ↑⍪/rarg where each element in rarg is non-empty. This function is faster for sufficiently large data.
               ⍝ -----------------------------------------------------------------------------------
          rows←↑∘⍴¨rarg ⍝ recognized idiom
          numrows←+/rows
          R←(numrows,¯1↑⍴↑rarg)⍴↑,/,¨rarg ⍝ ,/PV is a recognized idiom
        ∇

        ∇ R←larg Data2SOAP R;isMLS;encoding
               ⍝ Transform an MLS or arbitrary APL data into a SOAP-MLS
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←isMLS {encoding} Data2SOAP data
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  data     - APL data to be prepared
               ⍝  isMLS    - whether the outer structure of <data> is intended as an MLS as opposed
               ⍝             to just some arbitrary APL data. Note that, if an MLS, the content of
               ⍝             any given row may itself still be arbitrary APL data. If an MLS were a
               ⍝             real APL datatype, you wouldn't need to pass <isMLS>. When going from
               ⍝             SOAP to APL, it can be determined if it is destined as an MLS or as
               ⍝             arbitrary APL data by inspecting the top-level element's 'xsi:type'
               ⍝             property.
               ⍝  encoding - applies when <isMLS> is 1. See MLS2SOAP. Default: 1
               ⍝  R        - SOAP-MLS
               ⍝
               ⍝ EXAMPLES:
               ⍝  mls←⊃(1 'prop' 10 (0 2⍴⊂'')) (1 'prop2' (20 30) (0 2⍴⊂''))
               ⍝  1) 0 Data2SOAP mls ==>
               ⍝      1 'array' ''      (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:ur-type[2,4]')
               ⍝      2 'a'     1       (1 2⍴'xsi:type' 'xsd:boolean')
               ⍝      2 'a'     'prop'  (1 2⍴'xsi:type' 'xsd:string')
               ⍝      2 'a'     10      (1 2⍴'xsi:type' 'xsd:int')
               ⍝      2 'array' ''      (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:string[0,2]')
               ⍝      3 'a'     ''      (0 2⍴⊂'')
               ⍝      2 'a'     1       (1 2⍴'xsi:type' 'xsd:boolean')
               ⍝      2 'a'     'prop2' (1 2⍴'xsi:type' 'xsd:string')
               ⍝      2 'array' ''      (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:int[2]')
               ⍝      3 'a'     20      (0 2⍴⊂'')
               ⍝      3 'a'     30      (0 2⍴⊂'')
               ⍝      2 'array' ''      (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:string[0,2]')
               ⍝      3 'a'     ''      (0 2⍴⊂'')
               ⍝  2) 1 Data2SOAP mls ==>
               ⍝      1 'prop'  10 (1 2⍴'xsi:type' 'xsd:int')
               ⍝      1 'prop2' '' (0 2⍴⊂'')
               ⍝      2 'array' '' (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:int[2]')
               ⍝      3 'a'     20 (0 2⍴⊂'')
               ⍝      3 'a'     30 (0 2⍴⊂'')
               ⍝
               ⍝ NOTES:
               ⍝  - According to the SOAP specification (section 5.1), if a given element has
               ⍝    non-empty content, it may not have subelements. For now, you must just be
               ⍝    careful about passing such an MLS.
               ⍝
               ⍝ SUBFNS:   MLS2SOAP APL2SOAP
               ⍝ -----------------------------------------------------------------------------------
          (isMLS encoding)←2↑larg,1
          :If isMLS ⋄ R←encoding MLS2SOAP R ⋄ :Else ⋄ R←APL2SOAP R ⋄ :EndIf
        ∇

        ∇ R←{larg}DecodeRequest xml;⎕IO
               ⍝ Decode a SOAP-XML request
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{decoding} {noCheckArray} DecodeRequest xml
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  xml          - SOAP-XML that is intended as a complete method-call
               ⍝  decoding     - see <decoding> in ⍙DecodeMethod except that [type] should not be
               ⍝                 passed when using the 3rd format of <decoding>.
               ⍝                 Default: 1
               ⍝  noCheckArray - see ⍙DecodeMethod.  Default: 0
               ⍝  R            - [1] - success boolean
               ⍝                 [2] - if success (R[1]=1):
               ⍝                        [1] - name of the method
               ⍝                        [2] - method argument as an MLS or arbitrary APL data
               ⍝                        [3] - PVM for the attributes applied to the method,
               ⍝                              e.g. <MyMethod xmlns="..."> ==> 1 2⍴'xmlns' '...'
               ⍝                       if failure (R[1]=0):
               ⍝                        3-element vector describing a SOAP Fault. If passed to
               ⍝                        SOAPFault and then to MLS2XML, it yields a complete SOAP
               ⍝                        Fault XML string (complete body of an HTTP response).
               ⍝                        Important: Whenever such XML is returned, you should also
               ⍝                        return an HTTP status of '500 Internal Server Error'.
               ⍝
               ⍝ SUBFNS:   APLType ⍙DecodeMethod
               ⍝ -----------------------------------------------------------------------------------
          ⎕IO←1
          ⎕SHADOW'⎕ML'
          ⎕ML←3 ⍝ Protect. Even though we set ⎕ML to 3 in this namespace, a caller could localize it and then run ⎕CS, thereby setting it globally here.)
         
          :If 0=⎕NC'larg' ⋄ larg←1 0
          :ElseIf 1=×/⍴larg ⋄ larg←(larg 0)0
          :Else
              :If 0<≡2⊃larg ⋄ larg←larg 0 ⋄ :EndIf
              :If 0<≡1⊃larg ⋄ larg[1]←⊂(1⊃larg)0 ⋄ :EndIf
          :EndIf
         
          R←larg ⍙DecodeMethod xml
        ∇

        ∇ R←{larg}DecodeResponse xml;⎕IO
               ⍝ Decode a SOAP-XML response
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{decoding} {noCheckArray} DecodeResponse xml
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  xml          - SOAP-XML (result of calling some method via SOAP)
               ⍝  decoding     - see <decoding> in ⍙DecodeMethod except that [type] should not be
               ⍝                 passed when using the 3rd format of <decoding>.
               ⍝                 Default: 1
               ⍝  noCheckArray - see ⍙DecodeMethod.  Default: 0
               ⍝  R            - result as APL data
               ⍝                  [1] -  1 - success
               ⍝                         0 - failure - a SOAP Fault structure is in 2nd element
               ⍝                        ¯1 - failure - the SOAP message could not be decoded
               ⍝                  [2] - if success (R[1]=1):
               ⍝                         [1] - name of the method
               ⍝                         [2] - method result as an MLS or arbitrary APL data
               ⍝                         [3] - PVM for the attributes applied to the method,
               ⍝                               e.g. <MyMethod xmlns="..."> ==> 1 2⍴'xmlns' '...'
               ⍝                        if failure (R[1]≤0):
               ⍝                          SOAP Fault structure (see ∇SOAPFault)
               ⍝
               ⍝ SUBFNS:   APLType ⍙DecodeMethod
               ⍝ -----------------------------------------------------------------------------------
          ⎕IO←1
          ⎕SHADOW'⎕ML'
          ⎕ML←3 ⍝ Protect. Even though we set ⎕ML to 3 in this namespace, a caller could localize it and then run ⎕CS, thereby setting it globally here.)
         
          :If 0=⎕NC'larg' ⋄ larg←1 0
          :ElseIf 1=×/⍴larg ⋄ larg←(larg 1)0
          :Else
              :If 0<≡2⊃larg ⋄ larg←larg 0 ⋄ :EndIf
              :If 0<≡1⊃larg ⋄ larg[1]←⊂(1⊃larg)1 ⋄ :EndIf
          :EndIf
         
               ⍝ We'll just leverage ⍙DecodeMethod since it's doing the work we need here but we
               ⍝ need to modify the method name (drop 'Response' part).
          :If ↑R←larg ⍙DecodeMethod xml
              R←2⊃R
              :If 1∊':Fault'⍷1⊃R ⍝ Did the server send back a SOAP Fault structure? (the method "name" is 'SOAP-ENV:Fault')
                  R←0((2⊃R)[;3])
              :Else
                  R[1]←⊂{(¯8×'Response'≡¯8↑⍵)↓⍵}1⊃R ⍝ 'FooResponse' ==> 'Foo'
                  R←1 R
              :EndIf
          :Else ⍝ this SOAP is invalid somehow and we constructed our own SOAP Fault structure in ⍙DecodeMethod
              R←¯1(2⊃R)
          :EndIf
        ∇

        ∇ R←I Descendants dv
               ⍝ Return the indices of the descendants for some specified index
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←I Descendants dv
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  dv       - depth vector
               ⍝  I        - index to find the descendants of
               ⍝  R        - indices of the descendants, in ascending order
               ⍝ -----------------------------------------------------------------------------------
          R←I+⍳¯1+(dv[I]≥I↓dv)⍳1
        ∇

        ∇ R←I DescendantsAndSelf dv
               ⍝ Return the indices of the descendants and self for some specified index
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←I DescendantsAndSelf dv
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  dv       - depth vector
               ⍝  I        - index to find the descendants of
               ⍝  R        - indices of the descendants and self, in ascending order
               ⍝ -----------------------------------------------------------------------------------
          R←I+¯1+⍳(dv[I]≥I↓dv)⍳1
        ∇

        ∇ R←{larg}EncodeRequest rarg;⎕IO;A
               ⍝ Encode a SOAP-XML request
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{isMLS} {encoding} {xmlencoding} EncodeRequest method methodarg {methodpvm}
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  method      - name of the method intended to be called
               ⍝  methodarg   - argument to the method
               ⍝  methodpvm   - PVM to apply to the method element.  Default: 0 2⍴⊂''
               ⍝  isMLS       - see <isMLS> in Data2SOAP.  Default: 1
               ⍝  encoding    - see <encoding> in ⍙EncodeMethod except that [type] should not be
               ⍝                passed when using the 3rd format of <encoding>.
               ⍝                Default: 0 (which is in alignment with WSDL binding use="literal")
               ⍝  xmlencoding - see <xmlencoding> in MLS2XML.  Default: 'UTF-8'
               ⍝  R           - SOAP-XML intended as a complete method-call
               ⍝
               ⍝ SUBFNS:   APLType ⍙EncodeMethod
               ⍝ -----------------------------------------------------------------------------------
          ⎕IO←1
          ⎕SHADOW'⎕ML'
          ⎕ML←3 ⍝ Protect. Even though we set ⎕ML to 3 in this namespace, a caller could localize it and then run ⎕CS, thereby setting it globally here.)
         
          A←1 0 'UTF-8'
          :If 0=⎕NC'larg' ⋄ larg←A
          :Else ⋄ larg←larg,(×/⍴larg)↓A
              :If 0<≡2⊃larg ⋄ larg[2]←⊂(2⊃larg)0 ⋄ :EndIf
          :EndIf
         
          R←larg ⍙EncodeMethod rarg
        ∇

        ∇ R←{larg}EncodeResponse rarg;⎕IO;A
               ⍝ Encode a SOAP-XML response
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   1) R←{type} {encoding} {xmlencoding} EncodeResponse method methodres {methodpvm}
               ⍝           2) R←¯1     {''}       {xmlencoding} EncodeResponse rarg_to_SOAPFault
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  method      - name of the method yielding <methodres>
               ⍝  methodres   - result of calling <method> (see <data> in Data2SOAP)
               ⍝  methodpvm   - PVM to apply to the method element (usually just the same as that
               ⍝                passed in the original SOAP request)
               ⍝                Default: 0 2⍴⊂''
               ⍝  rarg_to_SOAPFault - see rarg of ∇SOAPFault.
               ⍝                      Important: Whenever this is returned, you should also return
               ⍝                      an HTTP status of '500 Internal Server Error'.
               ⍝  type        - 0 or 1: see <isMLS> in EncodeRequest/Data2SOAP.
               ⍝                    ¯1: return a complete SOAP Fault structure as the result (see
               ⍝                        SOAPFault), as XML.
               ⍝                Default: 1
               ⍝  encoding    - see <encoding> in ⍙EncodeMethod except that [type] should not be
               ⍝                passed when using the 3rd format of <encoding>.
               ⍝                Default: 0 (which is in alignment with WSDL binding use="literal")
               ⍝  xmlencoding - see ∇MLS2XML. Default: 'UTF-8'
               ⍝  R           - SOAP-XML intended to be passed back as a result, typicall in an HTTP body
               ⍝
               ⍝ SUBFNS:   APLType ⍙EncodeMethod MLS2XML SOAPFault
               ⍝ -----------------------------------------------------------------------------------
          ⎕IO←1
          ⎕SHADOW'⎕ML'
          ⎕ML←3 ⍝ Protect. Even though we set ⎕ML to 3 in this namespace, a caller could localize it and then run ⎕CS, thereby setting it globally here.)
         
          A←1 0 'UTF-8'
          :If 0=⎕NC'larg' ⋄ larg←A ⋄ :Else ⋄ larg←larg,(×/⍴larg)↓A ⋄ :EndIf
         
          :If 0≤↑larg
              :If 0<≡2⊃larg ⋄ larg[2]←⊂(2⊃larg)1 ⋄ :EndIf
              rarg[1]←⊂(1⊃rarg),'Response'
              R←larg ⍙EncodeMethod rarg
          :Else
              :If 3=≡rarg ⋄ rarg←2⊃rarg ⋄ :EndIf ⍝ (in case they included the method name first)
              R←(3⊃larg)MLS2XML SOAPFault rarg
          :EndIf
        ∇

        EndsWith←{⍵≡(-⍴⍵)↑⍺}

        ∇ R←IsSimpleValue value
          :If 1<≡value ⍝ nested
              R←0
          :ElseIf (⎕DR value)∊82 80 160 320 ⍝ character
              R←↑1≥⍴⍴value
          :Else ⍝ numeric
              R←⍬≡⍴value
          :EndIf
        ∇

        ∇ R←{encoding}MLS2SOAP R;mls;content;I;pvm;mv;J;type
               ⍝ Transform an MLS into a SOAP-MLS
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{encoding} MLS2SOAP mls
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  mls      - fully formed MLS
               ⍝  encoding - 0  - do not apply any datatype tagging to any elements
               ⍝             1  - apply datatype tagging to each element according to its APL
               ⍝                  datatype. However, for a given element, if its PVM contains the
               ⍝                  attribute 'xsi:type', then its value is preserved (it's not
               ⍝                  overwritten with the mapped APL datatype).
               ⍝             apimls - apply datatype tagging according to the passed API-MLS.
               ⍝                      This API-MLS follows the format described in API2WSDL
               ⍝                      (2nd or 3rd element for a given method description).
               ⍝             Observation: If all of the elements' datatypes are native to APL, then
               ⍝             the 3rd format for <encoding> will yield the same result as <encoding>=1.
               ⍝             Default: 1
               ⍝  R        - SOAP-MLS. It's basically the same as the passed MLS but for each row,
               ⍝             a datatype is somehow applied as an attribute. Also, "non-simple"
               ⍝             content is spread out as more rows (a SOAP "array").
               ⍝
               ⍝ EXAMPLE:
               ⍝  mls←0 4⍴0
               ⍝  mls←mls⍪1 'prop1' 'this'       (0 2⍴⊂'')
               ⍝  mls←mls⍪1 'prop2' (5 10)       (0 2⍴⊂'')
               ⍝  mls←mls⍪1 'prop3' ('more' 7.5) (0 2⍴⊂'')
               ⍝  MLS2SOAP mls ==>
               ⍝      1 'prop1' 'this' (1 2⍴'xsi:type' 'xsd:string')
               ⍝      1 'prop2' ''     (0 2⍴⊂'')
               ⍝      2 'array' ''     (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:int[2]')
               ⍝      3 'a'     5      (0 2⍴⊂'')
               ⍝      3 'a'     10     (0 2⍴⊂'')
               ⍝      1 'prop3' ''     (0 2⍴⊂'')
               ⍝      2 'array' ''     (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:ur-type[2]')
               ⍝      3 'a'     'more' (1 2⍴'xsi:type' 'xsd:string')
               ⍝      3 'a'     7.5    (1 2⍴'xsi:type' 'xsd:double')
               ⍝
               ⍝ SUBFNS:   ∆MV IsSimpleValue
               ⍝           PVMGetVal Ancestors MLSFind (if <encoding> is an API-MLS)
               ⍝           APL2SOAP
               ⍝ -----------------------------------------------------------------------------------
          :If 0=⎕NC'encoding' ⋄ encoding←1 ⋄ :EndIf
         
          mv←∆MV
          I←1
          :While I≤↑⍴R ⍝ (use :WHILE instead of :FOR because we may be expanding <R> on the fly)
              (content pvm)←R[I;3 4]
              :If content≡mv ⍝ (check this BEFORE calling IsSimpleValue so we don't try to run a potential ⎕NULL through it [⎕DR])
                  :If ~0≡encoding ⋄ pvm←pvm⍪'xsi:null' 1 ⋄ :EndIf
                  R[I;3 4]←''pvm ⍝ clean up - be sure to rid ∆mv (or ⎕NULL) from the content
                  I←I+1
         
              :ElseIf IsSimpleValue content
                  :If ~0≡encoding
                      :If ~content≡''
                      :OrIf I=↑⍴R ⋄ :OrIf ≥/R[I+0 1;1] ⍝ this means "if no descendants" (SOAP doesn't actually allow for a container to have non-empty content at its level, but we will allow it)
                          :If 1≡encoding
                              :If ~(⊂'xsi:type')∊pvm[;1] ⍝ if not already specified, e.g. 1 2⍴'xsi:type' 'xsd:dateTime'
                                  R[I;4]←⊂pvm⍪'xsi:type'('xsd:',(82 80 160 320 83 163 323 645 11⍳⎕DR content)⊃(4⍴⊂'string'),(3⍴⊂'int'),'double' 'boolean') ⍝ (Be sure to use 'double', not 'float', since APL "float" is 64-bit, not 32-bit.)
                              :EndIf
                          :Else ⍝ API-MLS
                              :If 0≠J←encoding MLSFind R[(I Ancestors R[;1]),I;2]
                              :AndIf ~mv≡type←'datatype'PVMGetVal(⊂J 4)⊃encoding
                                  :If ~':'∊type ⋄ type←'xsd:',type ⋄ :EndIf
                                  R[I;4]←⊂pvm⍪'xsi:type'type
                              :EndIf
                          :EndIf
                      :EndIf
                  :EndIf
                  I←I+1
         
              :Else ⍝ we'll have to form a SOAP "array" and shove it in underneath this row
                  mls←APL2SOAP content
                  R[I;3]←⊂'' ⍝ clear it out
                  mls[;1]←mls[;1]+R[I;1] ⍝ adjust to fit under this parent
                  R←(I↑[1]R)⍪mls⍪I↓[1]R
                  I←I+1+↑⍴mls ⍝ move on to next row, adjusting for how many rows we just added
              :EndIf
          :EndWhile
        ∇

        ∇ R←{encoding}MLS2XML mls;⍙mlchars;text;xlate;AV;apltype
               ⍝ Transform an MLS into XML
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX: R←{encoding} MLS2XML mls
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  mls      - fully-formed MLS
               ⍝  encoding - type of encoding for the resulting XML.
               ⍝             It can be one of the following:
               ⍝              ''                 - don't use any encoding
               ⍝              'UTF-8'            - this is the default
               ⍝              'UTF-16', 'UTF-32' - can only be used in Dyalog 12 or later
               ⍝  R        - XML
               ⍝
               ⍝ SUBFNS: APLType ∆AV ∆MV
               ⍝         ⍙MLS2XML ⍙MLS2XML_SprTags ⍙MLS2XML_Beg ⍙MLS2XML_PVM ⍙MLS2XML_End MLS
               ⍝         TextRepl
               ⍝         UTF8Encode (unless using Dyalog 12)
               ⍝ -----------------------------------------------------------------------------------
          :If 0=⎕NC'encoding' ⋄ encoding←'UTF-8' ⋄ :EndIf
         
          mls[;1]←mls[;1]-↑mls ⍝ adjust since ⎕XML uses depth-origin of 0 because it always has exactly 1 root (unless empty, of course)
          R←('whitespace' 'preserve')('markup' 'preserve')('unknown-entity' 'preserve')⎕XML mls ⍝ ['whitespace' 'preserve'] in this context actually means to NOT add whitespace/formatting to the result
          :If ~''≡encoding ⋄ R←⎕UCS encoding ⎕UCS R ⋄ :EndIf
        ∇

        ∇ R←mls MLSFind path;B
               ⍝ Find the first matching path in some MLS
               ⍝∇∇{*:⎕ERROR 'DOMAIN ERROR'}
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←mls MLSFind path
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  path     - hierarchical path to find, e.g. 'Parent' 'Child' 'Grandchild'
               ⍝  mls      - fully formed MLS to find the path in (only the first 2 columns need to
               ⍝             be passed)
               ⍝  R        - first row number of <mls> where the path is found; 0 if not found.
               ⍝
               ⍝ NOTES:
               ⍝  - This does not currently work on an MLS that has multiple tags in a single element,
               ⍝    e.g. 1 4⍴1 (,¨'b' 'u') 'somtext' ∆epvm
               ⍝ -----------------------------------------------------------------------------------
         
          :If 0∊⍴mls ⋄ R←0 ⋄ :Return ⋄ :EndIf
         
          :If 82=⎕DR path
              :If (↑⍴mls)<R←(⊂[2]mls[;1 2])⍳⊂(↑mls)path ⋄ R←0 ⋄ :EndIf
          :ElseIf 1=⍴path←,path
              :If (↑⍴mls)<R←(⊂[2]mls[;1 2])⍳⊂(↑mls),path ⋄ R←0 ⋄ :EndIf
          :Else
              mls[;1]←mls[;1]-¯1+↑mls ⍝ normalize the depth vector
              :For R :In B/⍳⍴B←mls[;1 2]∧.≡(⍴path),¯1↑path ⍝ where all the path's last node matches in the MLS
                  :If mls[R-(⌽(R-1)↑mls[;1])⍳⍳mls[R;1]-1;2]≡¯1↓path ⍝ ancestors match?
                      :Return ⍝ found it
                  :EndIf
              :EndFor
              R←0 ⍝ if we made it past the loop (or we didn't even get into the loop), we haven't found it
          :EndIf
        ∇

        ∇ R←mls MLSFindAncProp rarg;ancestors;I;J;prop;pvm;row
               ⍝ In some MLS, look for some property up the ancestor tree
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←mls MLSFindAncProp prop row
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  prop     - property to find
               ⍝  row      - row number of the MLS to begin the search at
               ⍝  mls      - MLS
               ⍝  R        - [1] - row number of the ancestor where the property is found (0 if not found)
               ⍝             [2] - associated value ('' if not found)
               ⍝
               ⍝ SUBFNS:   Ancestors
               ⍝ -----------------------------------------------------------------------------------
          :If 0=↑⍴mls ⋄ R←0 '' ⋄ :Return ⋄ :EndIf
          (prop row)←rarg
          ancestors←row,⌽row Ancestors mls[;1]
          I←0
          :Repeat
              pvm←4⊃mls[R←ancestors[I←I+1];]
              :If (↑⍴pvm)≥J←pvm[;1]⍳⊂prop
                       ⍝ Found it ==> bolt now with the value attached.
                  R←R,pvm[J;2]
                  :Return
              :EndIf
          :Until I=⍴ancestors
          R←0 '' ⍝ wasn't found
        ∇

        ∇ R←mls MLSSubset rarg;defval;path
               ⍝ Get a descendant subset of a passed MLS, starting with the row or path
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   1) R←mls MLSSubset path {defval}
               ⍝           2) R←mls MLSSubset row
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  path     - hierarchical path to find, e.g. 'Parent' 'Child' 'Grandchild'
               ⍝  defval   - default value.  This is returned as the result if the path is not found.
               ⍝             Default: ∆MV
               ⍝  row      - scalar row number of the MLS (instead of finding the path)
               ⍝  mls      - fully formed MLS
               ⍝  R        - descendant subset MLS (depths are preserved)
               ⍝
               ⍝ SUBFNS:   ∆MV MLSFind DescendantsAndSelf
               ⍝ -----------------------------------------------------------------------------------
          :If 0<≡rarg
              :If 3≤≡rarg ⋄ (path defval)←rarg
              :Else ⋄ (path defval)←rarg ∆MV
              :EndIf
              rarg←mls MLSFind path
              :If 0=rarg ⋄ R←defval ⋄ :Return ⋄ :EndIf
          :EndIf
          R←mls[rarg DescendantsAndSelf mls[;1];]
        ∇

        ∇ R←MakePVP R
          :If 0=⍴⍴R ⍝ (check for Dyalog because of prototypes)
              R←0⍴⊂''
          :ElseIf 2≠⍴R
              R←(↑R)(1↓R)
          :EndIf
        ∇

        ∇ R←prop PVMGetVal pvm;B;defval;I;mv
               ⍝ Return the value of the specified property in the PVM; default to specified value or to ∆MV
               ⍝ -----------------------------------------------------------------------------------
          :If B←1<≡prop ⋄ (prop defval)←prop ⋄ :EndIf
         
          mv←∆MV
          :If (↑⍴pvm)≥I←pvm[;1]⍳⊂prop
              R←(⊂I 2)⊃pvm
              :If B ⋄ :AndIf mv≡R ⍝ we should still override with defval if the value in the <pvm> is just ∆mv
                  R←defval
              :EndIf
          :ElseIf B
              R←defval
          :Else
              R←mv
          :EndIf
        ∇

        ∇ R←props PVMGetVals pvm;B;I;mv
               ⍝ Return the values of the specified properties in the PVM; default to specified respective value or to ∆MV
               ⍝ -----------------------------------------------------------------------------------
          mv←⊂∆MV
          :If 2=≡props
              R←(pvm[;2],mv)[pvm[;1]⍳props]
          :Else
                   ⍝ Some default values were passed with one or more properties.
              pvm←(~pvm[;2]∊mv)⌿pvm ⍝ don't allow a value of ∆mv in the <pvm> take precedence over a default value
              I←WHERE B←1=≡¨props
              props[I]←⊂[2]props[I],[1.5]mv
              props[I]←MakePVP¨props[I←WHERE~B]
              (props R)←⊂[1]⊃props
              I←pvm[;1]⍳props
              B←I≤↑⍴pvm
              R[WHERE B]←pvm[B/I;2]
          :EndIf
        ∇

        ∇ R←I Parent dv
               ⍝ Return the index of the parent for some specified index
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←I Parent dv
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  dv       - depth vector
               ⍝  I        - index to find the parent of
               ⍝  R        - index of the parent
               ⍝ -----------------------------------------------------------------------------------
          R←I-(⌽(I-1)↑dv)⍳dv[I]-1
        ∇

        ∇ R←{larg}PrepareWSDL rarg;⎕IO;api;decl;pvm;encoding;decl2
               ⍝ Prepare a WSDL document given a description of the API (cover for API2WSDL)
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{encoding} {decl} PrepareWSDL api pvm
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  api      - see API2WSDL
               ⍝  pvm      - see API2WSDL
               ⍝  encoding - see MLS2XML
               ⍝  decl     - additional processing instructions, e.g. for XSLT
               ⍝  R        - XML form of the result returned from API2WSDL
               ⍝
               ⍝ SUBFNS:   APLType MLS2XML API2WSDL
               ⍝ -----------------------------------------------------------------------------------
          ⎕IO←1
          ⎕SHADOW'⎕ML'
          ⎕ML←3 ⍝ Protect. Even though we set ⎕ML to 3 in this namespace, a caller could localize it and then run ⎕CS, thereby setting it globally here.)
         
          (api pvm)←rarg
         
          :If 0=⎕NC'larg' ⋄ (encoding decl2)←'UTF-8' ''
          :ElseIf 82=⎕DR larg ⋄ (encoding decl2)←larg''
          :Else ⋄ (encoding decl2)←larg
          :EndIf
         
          decl←'<?xml version="1.0" '
          :If 0≠⍴encoding ⋄ decl←decl,'encoding="',encoding,'" ' ⋄ :EndIf
          decl←decl,'?>'
          R←decl,decl2,encoding MLS2XML pvm API2WSDL api
        ∇

        ∇ R←RepairDV dv;J;I
               ⍝ For a valid depth vector that had some elements removed, normalize it
               ⍝ -----------------------------------------------------------------------------------
          dv←dv+1-⌊/dv ⍝ normalize
          I←⍳0⌈⌈/dv
          J←⍳⍴dv
          R←+/2</0,⌈\⌈⍀J×[1]dv∘.=I
        ∇

        ∇ R←SOAP2APL mls;⍙depths;⍙info
               ⍝ Transform a SOAP-MLS into APL
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←SOAP2APL mls
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  mls      - SOAP-MLS
               ⍝  R        - APL data
               ⍝
               ⍝ SUBFNS:   APLType ∆MV ⍙SOAP2APL_Recurse Children
               ⍝ -----------------------------------------------------------------------------------
          ⍙depths←mls[;1]
          ⍙info←⊂[2]mls[;3 4]
          R←1 ''⍙SOAP2APL_Recurse 1⊃⍙info
        ∇

        ∇ R←{decoding}SOAP2Data mls;I;pvm
               ⍝ Transform a SOAP-MLS into an MLS or arbitrary APL data
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{decoding} SOAP2Data mls
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  mls      - SOAP-MLS (presumably just from running SOAP-XML through XML2MLS).
               ⍝  decoding - this is applicable when SOAP2MLS has to be called. See SOAP2MLS. Default: 1
               ⍝  R        - [1] - success bit
               ⍝             [2] - Success:
               ⍝                     An MLS or arbitrary APL data (an MLS itself may contain non-simple APL data).
               ⍝                     Basically what happens here is the SOAP datatype attributes are
               ⍝                     applied and what results is one of:
               ⍝                     1) The content portions of the MLS become "APL data" (which
               ⍝                        includes absorbing SOAP arrays into content).
               ⍝                     2) The MLS is transformed into some arbitrary APL data (the top-level
               ⍝                        element of the SOAP-XML is a SOAP "array").
               ⍝                   Failure: error messsage
               ⍝
               ⍝ SUBFNS:   SOAP2MLS SOAP2APL
               ⍝ -----------------------------------------------------------------------------------
          :If 0∊⍴mls
              R←1(0 4⍴0 '' ''(0 2⍴⊂''))
          :Else
              pvm←4⊃mls[1;]
              :If (↑⍴pvm)≥I←⌊/pvm[;1]⍳'xsi:type' 'type' ⍝ is there a datatype specified for this element?
              :AndIf 1∊':Array'⍷2⊃pvm[I;] ⍝ at the top-level, we have a SOAP array ==> get as APL data
                  R←1(SOAP2APL mls)
              :Else ⍝ the top-level is a natural MLS (there may be some embedded arrays but SOAP2MLS handles that)
                  :If 0=⎕NC'decoding' ⋄ decoding←1 ⋄ :EndIf
                  R←1(decoding SOAP2MLS mls)
              :EndIf
          :EndIf
        ∇

        ∇ R←{decoding}SOAP2MLS R;I;mv;D;content;pvm;type;apimls;B;isAPI;tag;J;strippvm;PVM
               ⍝ Transform a SOAP-MLS into an MLS that contains normalized/datatype'd data
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{decoding} SOAP2MLS mls
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  mls      - SOAP-MLS
               ⍝  decoding - this is the type of decoding to perform. Default: 1
               ⍝               0  - no decoding. Just form an MLS without applying any data
               ⍝                    transformations.
               ⍝               1  - expect datatype tagging for each element (except containers)
               ⍝                    and transform them to their APL equivalent. For a given element,
               ⍝                    if its PVM contains a value for 'xsi:type' that does not
               ⍝                    transform to an APL datatype, then that attribute/value pair
               ⍝                    is preserved in the MLS and the data/content is not affected.
               ⍝              apimls - expect no datatype tagging; apply data transformations
               ⍝                       according to the passed API-MLS.
               ⍝                       This API-MLS follows the format described in API2WSDL
               ⍝                       (2nd or 3rd element for a given method description).
               ⍝             Note that regardless of what value is passed for <decoding>, any
               ⍝             arbitrary APL data found in content is appropriately transformed.
               ⍝  R        - MLS with the content transformed into normalized data (as specified by
               ⍝             the SOAP datatypes). The content of a given row can be arbitrary APL
               ⍝             data. SOAP allows for non-simple data using a SOAP "array" which can
               ⍝             be embedded in a true SOAP-MLS (the XML).
               ⍝
               ⍝ EXAMPLE:
               ⍝  mls←0 4⍴0
               ⍝  mls←mls⍪1 'tag1'  ''         (0 2⍴⊂'')
               ⍝  mls←mls⍪2 'sub1'  'this'     (1 2⍴'xsi:type' 'xsd:string')
               ⍝  mls←mls⍪2 'sub2'  '5'        (1 2⍴'xsi:type' 'xsd:int')
               ⍝  mls←mls⍪2 'sub3'  ''         (0 2⍴⊂'')
               ⍝  mls←mls⍪3 'array' ''         (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:ur-type[4]')
               ⍝  mls←mls⍪4 'a'     '2'        (1 2⍴'xsi:type' 'xsd:int')
               ⍝  mls←mls⍪4 'a'     'more'     (1 2⍴'xsi:type' 'xsd:string')
               ⍝  mls←mls⍪4 'array' ''         (2 2⍴'xsi:type' 'SOAP-ENC:Array' 'SOAP-ENC:arrayType' 'xsd:int[2]')
               ⍝  mls←mls⍪5 'a'     '10'       (0 2⍴⊂'')
               ⍝  mls←mls⍪5 'a'     '20'       (0 2⍴⊂'')
               ⍝  SOAP2MLS mls ==>
               ⍝      1 'tag1'  ''                 (0 2⍴⊂'')
               ⍝      2 'sub1'  'this'             (0 2⍴⊂'')
               ⍝      2 'sub2'  5                  (0 2⍴⊂'')
               ⍝      2 'sub3'  (2 'more' (10 20)) (0 2⍴⊂'')
               ⍝
               ⍝ SUBFNS:   APLType ∆MV PVMGetVal Descendants Ancestors MLSFind RepairDV
               ⍝           SOAP2APL
               ⍝ -----------------------------------------------------------------------------------
               ⍝⍝⍝⍝ First, get rid of any extraneous elements (the ones that end in "_WSDLPart"). They
               ⍝⍝⍝⍝ are just part of the WSDL machinery; WSDL needed them as wrappers in order to apply
               ⍝⍝⍝⍝ any constraints to datatypes, e.g. 'minOccurs'.
               ⍝⍝⍝:IF 1∊B←(¯9↑¨R[;2])∊⊂'_WSDLPart' ⋄ R←(~B)⌿R ⋄ R[;1]←RepairDV R[;1] ⋄ :ENDIF
         
          :If 0∊⍴R ⋄ :Return ⋄ :EndIf
         
          :If isAPI←2=⎕NC'decoding'
              :If isAPI←0<≡decoding
                  apimls←decoding
              :EndIf
          :Else
              decoding←1
          :EndIf
         
          R[;1]←R[;1]-(↑R)-1 ⍝ normalize
          I←1
          mv←∆MV
          :Repeat
              (tag content pvm)←R[I;2 3 4]
              strippvm←1
              :If isAPI
                  :If (⍴tag)≥J←tag⍳':' ⍝ we're just going to remove any namespace prefixes that some SOAP encoder may have put there)
                      R[I;2]←⊂J↓tag
                  :EndIf
                  :If 0=J←apimls MLSFind R[(I Ancestors R[;1]),I;2]
                  :OrIf mv≡type←'datatype'PVMGetVal PVM←(⊂J 4)⊃apimls
                      :GoTo ∆end
                  :ElseIf (↑⍴pvm)≥J←pvm[;1]⍳⊂'xsi:null' ⋄ :AndIf (,'1')≡⍕(⊂J 2)⊃pvm ⍝ null specified?
                      type←'null' ⍝ so the value becomes ∆MV
                  :Else
                      strippvm←0
                      R[I;4]←⊂{⎕ML←1 ⋄ ↑∪↓⍵}pvm⍪PVM ⍝⍝⍝BPB add WSDL specification in if not there
                  :EndIf
              :ElseIf 0=decoding ⍝ we'll only continue if we have some arbitrary to transform
                  :If ~(↑⍴pvm)≥J←pvm[;1]⍳⊂'xsi:type' ⍝ is there a datatype specified for this element?
                  :OrIf ~'Array'≡type←(type⍳':')↓type←(⊂J 2)⊃pvm
                      :GoTo ∆end
                  :EndIf
              :ElseIf (↑⍴pvm)≥J←pvm[;1]⍳⊂'xsi:type' ⍝ is there a datatype specified for this element?
                  type←(⊂J 2)⊃pvm
                  type←(type⍳':')↓type ⍝ the type for comparison purposes
              :ElseIf (↑⍴pvm)≥J←pvm[;1]⍳⊂'xsi:null' ⋄ :AndIf (,'1')≡⍕(⊂J 2)⊃pvm ⍝ null specified?
                  type←'null'
              :Else
                  :GoTo ∆end
              :EndIf
         
              :Select type
              :Case 'string' ⍝ just capture it so we don't go into the :ELSE below
              :CaseList 'int' 'float' 'double' 'boolean' 'integer' ⍝ 'integer' comes from an API-MLS but 'int' comes from 'xsd:int'
                  content←(⊂I 3)⊃R
                  :If (⎕DR content)∊82 80 160 320
                        ⍝⍝⍝BPB - this checking is disabled for now until we implement better validation
                        ⍝        "true" and "false" need to be supported as boolean values
                        ⍝        checking needs to be defered until we implement better SOAP FAULT support
          ⍝                 :If ''≡content ⍝ (this really shouldn't be allowed since null should have been used instead)
          ⍝                    R[I;3]←⊂mv
          ⍝                 :Else
          ⍝                    :If content[1]='-' ⋄ content[1]←'¯' ⋄ :EndIf
          ⍝                    R[I;3]←2 1⊃⎕VFI content
          ⍝                 :EndIf
                  :EndIf
              :Case 'Array' ⍝ (was 'SOAP-ENC:Array')
                  D←I,I Descendants R[;1]
                  R[I-1;3]←⊂SOAP2APL R[D;] ⍝ tuck up into its parent's content
                  R←R[(⍳↑⍴R)~D;] ⍝ rid these descendants since they've just been absorbed
                  I←I-1 ⍝ account for the descendants having gone away
                  :GoTo ∆end ⍝ skip over the part that messes with the pvm for this row (this row has been removed by now)
         
              :Case 'null'
                  R[I;3]←⊂mv
         
              :Else ⍝ e.g. 'xsd:dateTime' 'xsd:base64' ''
                       ⍝ Leave the datatype attribute intact for the application developer to pick up on.
                  :GoTo ∆end
         
              :EndSelect
         
                   ⍝ Remove the 'xsi:type' or 'xsi:null' attribute. We can end up with
                   ⍝ 0 2⍴⊂'    ' or something like that (instead of the normalized 0 2⍴⊂'')
                   ⍝ so we'll check explicitly for whether that's about to happen and remedy.
              :If strippvm
                  :If 1=↑⍴pvm ⋄ R[I;4]←⊂0 2⍴⊂''
                  :Else ⋄ R[I;4]←⊂pvm[(⍳↑⍴pvm)~J;]
                  :EndIf
              :EndIf
         
         ∆end:
          :Until (↑⍴R)<I←I+1
        ∇

        ∇ R←SOAPFault rarg;code;detail;string;epvm
               ⍝ Construct a SOAP Fault structure as an MLS
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←SOAPFault code string detail
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  code       - charvec - code for identifying the error.
               ⍝               It is of the form: Generic.Specific, e.g. 'Client.Authentication'.
               ⍝               The generic part must be one of the following:
               ⍝                'VersionMismatch' 'MustUnderstand' 'DataEncodingUnknown' 'Client' 'Server'
               ⍝               The specific part is probably something like:
               ⍝                'Invalid' 'Unexpected' 'Permission' ...
               ⍝  string     - charvec - description of the particular reason for failure (probably good
               ⍝               for an end-user type of message)
               ⍝  detail     - charvec - application specific details (probably good for a developer to analyze)
               ⍝  R          - fully formed SOAP-MLS. If converted to XML, it is suitable as the
               ⍝               complete body of an HTTP response.
               ⍝
               ⍝ NOTES:
               ⍝  - see http://www.w3c.org/tr/soap (Section 4.4 SOAP Fault)
               ⍝ -----------------------------------------------------------------------------------
         
          (code string detail)←rarg
         
          :If ~':'∊code ⋄ code←'SOAP-ENV:',code ⋄ :EndIf
         
          epvm←0 2⍴⊂''
         
          R←0 4⍴0
          R←R⍪1 '?xml version="1.0"?' ''epvm
          R←R⍪1 'SOAP-ENV:Envelope' ''(4 2⍴'SOAP-ENV:encodingStyle' 'http://schemas.xmlsoap.org/soap/encoding/' 'xmlns:SOAP-ENV' 'http://schemas.xmlsoap.org/soap/envelope/' 'xmlns:xsd' 'http://www.w3.org/2001/XMLSchema' 'xmlns:xsi' 'http://www.w3.org/2001/XMLSchema-instance')
          R←R⍪2 'SOAP-ENV:Body' ''epvm
          R←R⍪3 'SOAP-ENV:Fault' ''epvm
          R←R⍪4 'faultcode'code epvm
          R←R⍪4 'faultstring'string epvm
          R←R⍪4 'detail'detail epvm
        ∇

        ∇ R←TOUP R;L;B
               ⍝ For a character vector, convert all lowercase characters to uppercase characters
               ⍝ -----------------------------------------------------------------------------------
               ⍝ Be careful not to convert the traditionally-converted non-ASCII characters though (ÇÄÉÑÖÜ).
          (B/R)←'ABCDEFGHIJKLMNOPQRSTUVWXYZ'[L⍳(B←R∊L←'abcdefghijklmnopqrstuvwxyz')/R]
        ∇

        ∇ R←xlate TextRepl text;row;find;avail;repl;allB;findI;rows;B;rk;⎕IO
               ⍝ Replace sets of characters in some character vector (like TEXTREPL but doesn't use assembler)
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←xlate TextRepl text
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  text     - character vector to replace some characters in
               ⍝  xlate    - translation table, one row for each find/replace pair:
               ⍝              [;1] - characters to find
               ⍝              [;2] - characters to replace with
               ⍝             This may also be a segmented-string of the form '/find1/repl1/find2/repl2...'
               ⍝             (using any delimiter) like that used as the left argument to TEXTREPL.
               ⍝  R        - character vector with all of the replacements.
               ⍝             If some characters are found (in xlate[I;1]), they are replaced with
               ⍝             xlate[I;2] and then those characters cannot be found again, e.g.
               ⍝             (⊃('this here' 'that')('this' 'other')) TextRepl 'this here and this' ==> 'that and other'
               ⍝
               ⍝ SUBFNS:   APLType IsADS WHERE
               ⍝ -----------------------------------------------------------------------------------
         
          ⎕IO←1 ⍝ (yes, this is called by functions that set ⎕IO←0)
          rk←⍴⍴xlate
         
               ⍝ Validate the arguments.
          :If 1≠⍴⍴text ⋄ 'DOMAIN ERROR: TextRepl right argument'⎕SIGNAL 500 ⋄ :EndIf
          :If ~rk∊1 2 ⋄ 'DOMAIN ERROR: TextRepl left argument'⎕SIGNAL 501 ⋄ :EndIf
         
               ⍝ Transform a repl-string into a normalized N×2 matrix of find/repl.
          :If rk=1
              xlate←1↓¨(+\xlate=↑xlate)⊂xlate
              rows←0.5×⍴xlate
              :If rows≠⌈rows
                  'DOMAIN ERROR: TextRepl left argument'⎕SIGNAL 501
              :EndIf
              xlate←(rows,2)⍴xlate
          :Else
              rows←↑⍴xlate
          :EndIf
         
               ⍝ Initialize.
          R←text
          allB←(⍴text)⍴0
          avail←(⍴text)⍴1
               ⍝ivec←⍳⍴text
         
               ⍝ For Dyalog, create a derived function for faster performance
               ⍝ (also do this because there is no ⎕SS equivalent in Dyalog).
         
          :For row :In ⍳rows
              (find repl)←xlate[row;]
              B←find⍷text
              findI←WHERE avail∧B ⍝ (avail^B)/ivec
              R[findI]←⊂repl
              allB[findI]←1
              avail[¯1+∊findI+⊂⍳×/⍴find]←0
          :EndFor
         
          R←∊(avail∨allB)/R
        ∇

        ∇ R←{larg}UTF8Decode utf8;ucs;type;bad;mult;good;b;f;len;class;i;⎕IO
               ⍝ Decode a character vector that is encoded as UTF-8
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{ifbad} UTF8Decode utf8
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  utf8     - character vector that is encoded as UTF-8
               ⍝  ifbad    - how to treat "bad" unicode code points. A "bad" unicode code point just
               ⍝             means it has no counterpart in ⎕AV. This isn't actually possible in Dyalog 12.
               ⍝             The following values for <ifbad> are possible:
               ⍝              0 - insert the unicode code point (an integer for the decimal value)
               ⍝              1 - insert the XML form of '&#nnnn;', where nnnn is the decimal
               ⍝                  value for the unicode code point. However, '&' won't actually
               ⍝                  be used; unicode code point 27 (⎕TSESC) will be used instead.
               ⍝                  See ∇XMLUnescape for some discussion on why this is a reasonable convention.
               ⍝             Default: 0
               ⍝  R        - decoded character vector (can be heterogeneous, actually; see <ifbad> above).
               ⍝
               ⍝ NOTES:
               ⍝  ∘ See also UTF8Encode.
               ⍝
               ⍝ SUBFNS:
               ⍝  APL+Win, Dyalog pre-12: ∆AV ∆AVU
               ⍝  All:                    APLType
               ⍝ -----------------------------------------------------------------------------------
         
          R←'UTF-8'⎕UCS ⎕UCS utf8
        ∇

        ∇ R←UTF8Encode rarg;⎕IO;len;J;I;B;ucs;AV;DR
               ⍝ Encode a character vector as UTF-8
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX: R←UTF8Encode rarg
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  rarg   - character vector to be encoded as UTF-8.
               ⍝           Actually, a given element can also be an integer for the unicode code
               ⍝           point. This would only be necessary if not using Dyalog 12. Also, it
               ⍝           would only ever be needed for a unicode code point that is not in ∆AVU,
               ⍝           that is, it does not have a corresponding character in ⎕AV.
               ⍝           This allows for roundtrips using UTF8Encode and UTF8Decode, e.g.
               ⍝           p≡UTF8Decode UTF8Encode p←'AB',8734 8735,'CDE'
               ⍝  R      - UTF-8-encoded character vector
               ⍝
               ⍝ NOTES:
               ⍝  ∘ See also UTF8Decode, ∆AVU.
               ⍝  ∘ Unless we're in Dyalog 12, this function obviously cannot accept any real
               ⍝    unicode characters outside of ⎕AV. However, a given unicode code point can be
               ⍝    passed as an integer instead. Also, the writer of some XML could just use
               ⍝    '&#nnnn;' to specify such characters.
               ⍝  ∘ Some characters in ⎕AV are not mapped to a unicode point (have 65533 in
               ⍝    corresponding ∆AVU element) so take note that such characters will not make the
               ⍝    round trip as so: a≡UTF8Decode UTF8Encode a←(∆AVU=65533)/⎕AV ==> 0
               ⍝
               ⍝ SUBFNS:
               ⍝  APL+Win, Dyalog pre-12: ∆AV ∆AVU
               ⍝  All:                    APLType
               ⍝ -----------------------------------------------------------------------------------
         
          :If (⎕DR rarg)∊11 83 163 323 326 ⍝ this would be unusual, but it is allowed, and it nicely accommodates automated testing
              B←(⎕DR¨rarg)∊11 83 163 323
              (B/rarg)←⎕UCS B/rarg
          :EndIf
          R←⎕UCS'UTF-8'⎕UCS rarg
        ∇

        ∇ R←WHERE B
               ⍝ This is good to have as a subroutine so it can be easily modified without having
               ⍝ to change a lot of code that utilizes such a primitive action.
               ⍝ In APL+Win, it is written as assembler (faster for "large" data and not prone to WS FULL).
               ⍝ In Dyalog, we'll just use the standard idiom B/⍳⍴B, which is documented as being optimized.
          R←B/⍳⍴B
        ∇

        ∇ R←{larg}XML2MLS xml;⎕IO;cell;cells;cells_2;content;curdepth;endmark;endsI;hasText;hasTextB;index_cells;inQuotes;isStartTag;isWholeTag;jumpRow;noBump;pvm;row_R;specialB;tag;wspace;AV;endmarks;begs;B;B2;I;clean;decode;S;pre;isADS;ign_bad_att;apltype;A
               ⍝ Transform XML into an MLS
               ⍝∇∇{*:→∆err}
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←{clean} {decode} {ignore_bad_attribs} XML2MLS xml
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  xml      - XML string, encoded as UTF-8 (or ASCII, of course, which is just a subset of UTF-8)
               ⍝  clean    - (optional)
               ⍝              0 - preserve whitespace (default)
               ⍝              1 - force deletion of extraneous whitespace unless an element's
               ⍝                  'xml:space' attribute is set to 'preserve' (will look up at the
               ⍝                  ancestor tree to get the value).
               ⍝              2 - force deletion of extraneous whitespace.
               ⍝                  This is not currently available for Dyalog 12.1 or later.
               ⍝              3 - preserve whitespace but at least remove rows of the MLS that have
               ⍝                  '' as the tag and just whitespace for the content.
               ⍝                  This is not currently available for Dyalog 12.1 or later.
               ⍝  decode   - (optional) decode into unicode characters (or into ⎕AV if don't have unicode support yet)
               ⍝             Default: 0 ==> do not decode; leave as UTF-8.
               ⍝  ignore_bad_attribs - (optional) whether to ignore bad attribute sections instead
               ⍝                       of erroring. This is not currently available for Dyalog 12.1 or later.
               ⍝                       Default: 0
               ⍝  R        - MLS (encoded as UTF-8 unless <decode> in larg is set to 1)
               ⍝
               ⍝ SUBFNS:
               ⍝  APL+Win: States
               ⍝  Dyalog:  ⍙XML2MLS_Within
               ⍝  Both:    APLType IsADS ∆AV
               ⍝           WHERE XMLUnescape UTF8Decode
               ⍝           MLSFindAncProp (only if <clean> in <larg> is set to 1)
               ⍝
               ⍝ NOTES:
               ⍝  An XML parser should preserve all whitespace (unless it's outside of the root
               ⍝  tag, of course).  To respect the 'xml:space' attribute of any given tag and to
               ⍝  perhaps tighten up an MLS, see <clean>. The 'xml:space' attribute is not really
               ⍝  for parsers to respect; it is for the "application" to respect. It may have a
               ⍝  value of 'default' or 'preserve'. 'default' simply means to let the application
               ⍝  do whatever it deems appropriate.  'preserve' means that even the "application"
               ⍝  should not delete extraneous whitespace.
               ⍝ -----------------------------------------------------------------------------------
          ⎕IO←1
          :Trap 0
              :If 0=⎕NC'larg' ⋄ clean←decode←ign_bad_att←0 ⋄ :Else ⋄ (clean decode ign_bad_att)←3↑larg ⋄ :EndIf
         
               ⍝ ===================================================================================
              :Select clean
              :Case 0
                  A←'preserve'
              :Case 1
                  A←'strip' ⍝ 'xml:space' is still respected though
              :Case 2 ⍝ ⎕XML does not seem to have this option
                       ⍝ This will at least do the trick for automated testing purposes.
                  xml←(1 2⍴'xml:space="preserve"' 'xml2mls:space="preserve"')TextRepl xml
                  A←'strip'
              :Case 3 ⍝ ⎕XML does not seem to have this option ==> accommodate below though, for testing
                  A←'preserve'
              :EndSelect
         
              R←('whitespace'A)('markup' 'preserve')('unknown-entity' 'preserve')⎕XML xml
         
              :If 0∊⍴R
                  R←0 4⍴0 ⍝ (prototype for ⎕XML is 0 5⍴⊂⍬)
              :Else
                  R←4↑[2]R
                  R[;1]←R[;1]+1 ⍝ adjust since ⎕XML uses depth-origin of 0; it always has exactly 1 root (unless empty, of course)
         
                  :If clean=2 ⍝ undo our temporary kludge for allowing automated testing to run
                      :For I :In ⍳↑⍴R
                          pvm←(⊂I 4)⊃R
                          :If (↑⍴pvm)≥A←pvm[;1]⍳⊂'xml2mls:space'
                              pvm[A;1]←⊂'xml:space'
                              R[I;4]←⊂pvm
                          :EndIf
                      :EndFor
                  :ElseIf clean=3 ⍝ fixup so automated testing will work ==> ⍝ remove rows that have an empty tag and "empty" content
                  :AndIf 1∊B←R[;2]∊⊂''
                  :AndIf 1∊B2←∧/¨(B/R[;3])∊¨⊂∆AV[10 11 14 33]
                      R←(~B\B2)⌿R
                  :EndIf
         
                  :If decode
                      I←WHERE 0≠∊⍴¨R[;3] ⍝ (if we only work on the non-empty ones, we won't have to use the 1↓¨(+\A=⎕AV[1])⊂A algorithm)
                      A←∊⎕AV[1],¨R[I;3]
                      A←'UTF-8'⎕UCS ⎕UCS A
                      R[I;3]←(A≠⎕AV[1])⊂A ⍝ *** see if all of this is faster than: R[I;3]←(⊂'UTF-8') ⎕UCS¨ ⎕UCS¨ R[I;3]
                  :EndIf
              :EndIf
         
              :Return
         
          :Else
              :If ''≡xml~∆AV[10 11 14 33]
                  R←0 4⍴0
              :Else
                  'DOMAIN ERROR: The XML is not well-formed.'⎕SIGNAL 500
              :EndIf
          :EndTrap
        ∇

        ∇ R←∆AV
               ⍝ Return ⎕AV in APL+Win order whether in APL+Win or in Dyalog.
               ⍝ This returns ⎕AV in an order such that the 11 ⎕DR of it is in ascending order,
               ⍝ which can be the real value of using ∆AV in algorithms.
          R←⎕AV[⎕IO+0 43 44 58 91 92 6 7 1 9 2 10 5 3 11 235 220 221 222 223 224 225 226 227 228 229 230 8 219 238 217 250 4 204 215 216 61 12 218 13 185 248 180 169 194 168 46 156 48 49 50 51 52 53 54 55 56 57 240 193 160 162 164 172 231 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 155 158 249 167 16 237 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 123 192 125 175 95 124 126 191 190 245 246 176 177 161 163 196 195 253 254 203 96 207 64 183 198 197 205 206 181 182 159 157 186 187 188 189 166 251 243 63 62 59 60 127 252 128 247 244 47 165 209 208 45 184 179 200 199 201 202 239 94 14 173 241 210 178 174 15 242 129 97 98 99 130 131 132 100 101 134 102 103 104 105 106 107 108 135 109 110 111 112 136 171 137 113 114 115 138 116 117 139 140 141 142 118 143 144 145 146 147 148 149 150 119 151 152 153 120 154 121 211 212 122 213 170 214 232 233 234 236 93 133 255]
        ∇

        ∇ R←∆AVU
               ⍝ This is like ⎕AVU in Dyalog 12.
               ⍝ Return the unicode points that correspond to ⎕AV.
               ⍝ In APL+Win, ∆AVU has 28 occurrences of 65533 ("REPLACEMENT CHARACTER").
               ⍝ In Dyalog, ∆AVU doesn't have any of those; they're all mapped.
               ⍝
               ⍝ The following is a bit of information on some characters worthy of discussion:
               ⍝   *  ⍝ Dyalog uses 002A[42], as opposed to, e.g. 22C6, 2217
               ⍝   -  ⍝ Dyalog uses 002D[45], as opposed to, e.g. 2212
               ⍝   ¯  ⍝ 00AF[175]. There's no reason to mess with this (SOAP utils convert real negative numbers to the appropriate character, '-', outside of any character conversions).
               ⍝   ~  ⍝ Dyalog uses 007E[126], as opposed to, e.g. 223C
               ⍝   |  ⍝ Dyalog uses 007C[124], as opposed to, e.g. 2223
               ⍝   (broken stile)  ⍝ No reason to use anything but 00A6[166]. Dyalog doesn't have this in their ⎕AV.
               ⍝   ^  ⍝ In Dyalog ⎕AV, there is a "LOGICAL AND" character for this 2227[8743] (which is
               ⍝      ⍝ similar to "LOGICAL OR" at 2288[8744]). Dyalog also has a separate element, the
               ⍝      ⍝ "CIRCUMFLEX ACCENT" character 005E[94]. In APL+Win, since there is only
               ⍝      ⍝ one of them, we'll just use the ASCII character (∆AVU is set accordingly).
               ⍝  In APL+Win, the default value of ∆AVU will incorporate what Dyalog uses, when
               ⍝  applicable, in order to try to be as consistent as possible.
         
          R←⎕AVU
        ∇

        ∇ R←∆MV
               ⍝ Return "missing value"
               ⍝
               ⍝ Some problems with using ⎕NULL in Dyalog:
               ⍝  ⎕DR ⎕NULL ==> DOMAIN ERROR
               ⍝  ↑0⍴⎕NULL  ==> NONCE ERROR (makes it difficult to use in automated testing, e.g. use of ∇GenAPLData)
               ⍝                note: ↑1⍴⎕NULL ==> ⎕NULL (no problem here)
               ⍝
               ⍝ You can set your own "missing value" by setting ∆mv to any homogeneous value of depth
               ⍝ 1 or less. If it's not simple like that, it can get broken up by algorithms that
               ⍝ inspect it and work on it recursively.
               ⍝ -----------------------------------------------------------------------------------
          :If 0≠⎕NC'∆mv' ⋄ R←∆mv
          :Else ⋄ R←(4⍴2)⍴'MV' ⍝2+¯2*31
          :EndIf
        ∇

        ∇ R←depth ⍙APL2SOAP_Recurse data;type;dr;ch;chdr;I;B;s;A
               ⍝ Private subroutine of APL2SOAP
               ⍝ -----------------------------------------------------------------------------------
               ⍝ Return:
               ⍝  [;1] - depth (as in "depth vector", not ≡)
               ⍝  [;2] - data
               ⍝  [;3] - shape
               ⍝  [;4] - array-type
               ⍝           0 - non-"simple"
               ⍝           1 - "simple"
               ⍝          ¯1 - special (APL character non-vec)
               ⍝          ¯2 - NULL (according to what ∆MV returns)
               ⍝  [;5] - DR. If array-type is 0:
               ⍝              ∘ The DR of all its children are the same ==> use their DR
               ⍝                and mark 0 as the DR for each child (unless a given child
               ⍝                has children itself that it is already representing).
               ⍝                If all of the children are arrays, use 326.
               ⍝              ∘ If the children do not all have the same DR, use 807.
               ⍝             If array-type is 1 or ¯1, use the DR of the data.
               ⍝             If array-type is ¯2, use ¯1 as the DR.
               ⍝ -----------------------------------------------------------------------------------
               ⍝ Special case for NULL.
          :If data≡⍙mv ⍝ (⍙mv was localized in APL2SOAP)
              R←1 5⍴depth'' 0 ¯2 ¯1 ⍝ be sure to rid ∆mv (or ⎕NULL) from the content (use '' instead of <data>)
              :Return
          :EndIf
         
          dr←⎕DR data
          s←⍴data
         
               ⍝ ===================================================================================
               ⍝ * APL data is considered to be a SOAP-array only if it is one of the following:
               ⍝   ∘ nested
               ⍝   ∘ numeric non-scalar
               ⍝ * Put another way, it is NOT to be considered a SOAP-array if it is one the following:
               ⍝   ∘ character vector
               ⍝   ∘ numeric scalar
               ⍝ * However, the following simply do not have a counterpart in SOAP:
               ⍝   ∘ character data of any rank other than 1, e.g. 'A' or ⊃'this' 'that'
          :Select dr
          :CaseList 326 807 ⋄ type←0
          :CaseList 82 80 160 320 ⋄ :If 1=⍴s ⋄ type←1 ⋄ :Else ⋄ type←¯1 ⋄ :EndIf
          :Else ⋄ type←0=↑⍴s
          :EndSelect
         
               ⍝ ===================================================================================
          :If 0=type
              :If 0∊s
                       ⍝ This is good for preserving the prototype but we want all the other attributes to remain intact.
                  ch←(depth+1)⍙APL2SOAP_Recurse↑1↑0⍴data
              :Else
                       ⍝ ∇ConcatMats is faster than ↑⍪/ for large data. Using ⍪/ is especially
                       ⍝ inefficient simply because the bulk of the data that runs through
                       ⍝ ⍙APL2SOAP_Recurse is "simple" (ELSE case way down below); we could
                       ⍝ restructure everything to gather such 1-row results in a single step (big
                       ⍝ reshape). However, we seem to handle all of this more cleanly by just
                       ⍝ optimizing with ∇ConcatMats.
                       ⍝ (We could use the idiom ,/ (called "join") in Dyalog then reshape the
                       ⍝  data at the end of a cover function calling this.)
                       ⍝ch←↑⍪/(depth+1) ⍙APL2SOAP_Recurse¨ ,data
                  ch←ConcatMats(depth+1)⍙APL2SOAP_Recurse¨,data
              :EndIf
         
              B←ch[;1]=depth+1 ⍝ where the direct children are (there can be other descendants here, of course)
              I←WHERE B
              :If 0∧.=ch[I;4]
                  dr←326 ⍝ use this DR to show that all of the children are also "arrays"
                  ch[WHERE B∧0≠ch[;4];5]←0
              :ElseIf A∧.=chdr←↑A←ch[I;5]
                  dr←chdr ⍝ inherit the DR that is the same as all of the children
                  ch[WHERE B∧0≠ch[;4];5]←0
              :Else
                  dr←807 ⍝ use this DR to show that the children are of varying datatypes (even though Dyalog doesn't actually have 807)
              :EndIf
         
              R←depth''s type dr⍪ch ⍝ (might as well use '' as the spaceholder since it is appropriate for the final result in the calling function)
         
          :Else
              R←1 5⍴depth data s type dr
         
          :EndIf
        ∇

        ∇ R←larg ⍙DecodeMethod xml;noCheckArray;decoding;mls;D;api;type;methods;B;J;I;A;method;mpvm;envns
                        ⍝ Private subroutine of DecodeRequest and DecodeResponse - Decode a SOAP-XML method/data
                        ⍝ -----------------------------------------------------------------------------------
                        ⍝ SYNTAX:   R←decoding noCheckArray ⍙DecodeMethod xml
                        ⍝
                        ⍝ ARGS/RESULT:
                        ⍝  xml         - SOAP-XML that is intended as a complete method-call
                        ⍝  decoding    - applies when the XML yields an MLS (as opposed to arbitary APL data)
                        ⍝                This is the type of decoding to perform. Default: 1
                        ⍝                  0  - no decoding. Just form an MLS without applying any data
                        ⍝                       transformations.
                        ⍝                  1  - expect datatype tagging for each element (except containers)
                        ⍝                       and transform them to their APL equivalent. For a given element,
                        ⍝                       if its PVM contains a value for 'xsi:type' that does not
                        ⍝                       transform to an APL datatype, then that attribute/value pair
                        ⍝                       is preserved in the MLS and the data/content is not affected.
                        ⍝                 [api][type] - expect no datatype tagging; apply data transformations
                        ⍝                               according to the passed API:
                        ⍝                  api  - associated API for any method that may be passed in <xml>.
                        ⍝                         This API follows the format described in API2WSDL.
                        ⍝                  type - 0-request, 1-response. Note, this only needs to be passed
                        ⍝                         to determine which element to pick from the relevant
                        ⍝                         method's api-structure.
                        ⍝                Note that regardless of what value is passed for <decoding>, any
                        ⍝                arbitrary APL data found in content is appropriately transformed.
                        ⍝  noCheckArray - When not passed or set to 0, run the SOAP data through SOAP2Data
                        ⍝                 in order to determine whether the data is a SOAP array (intended
                        ⍝                 as some arbitrary APL) or it is some arbitrary XML (intended as an
                        ⍝                 MLS). It can generally be determined if the data is for conversion
                        ⍝                 to arbitrary APL (should be run through SOAP2APL) by seeing if the
                        ⍝                 top-level element attribute 'xsi:type' is set to 'SOAP-ENC:Array'.
                        ⍝                 However, the following is not a SOAP array and you may or may not
                        ⍝                 want it to be slated for conversion to APL.
                        ⍝                  <a xsi:type="xsd:int">120</a> ⍝ (can get this by running: MLS2XML APL2SOAP 120)
                        ⍝                 Hence, the reason for needing this argument.
                        ⍝  R           - [1] - success boolean
                        ⍝                [2] - if success (R[1]=1):
                        ⍝                        [1] - name of the method
                        ⍝                        [2] - data for the method (as its argument or as its result)
                        ⍝                        [3] - PVM for the attributes applied to the method,
                        ⍝                              e.g. <MyMethod xmlns="..."> ==> 1 2⍴'xmlns' '...'
                        ⍝                      if failure (R[1]=0):
                        ⍝                       3-element vector describing a SOAP Fault (see SOAPFault)
                        ⍝
                        ⍝ SUBFNS:   APLType XML2MLS Descendants SOAP2Data SOAP2APL
                        ⍝ -----------------------------------------------------------------------------------
          (decoding noCheckArray)←larg
         
          :Trap 0
              mls←3 1 XML2MLS xml
          :Else
              I←1 ⋄ :GoTo ∆invalid
          :EndTrap
         
                        ⍝ The only child of the body is the function name element. The children of the
                        ⍝ the function name element make up the argument to the function (I don't think
                        ⍝ there are rows in the MLS beyond those children but we'll use Descendants
                        ⍝ to be safe).
         
          :If 0∊⍴envns←(<\mls[;2]EndsWith¨⊂':Envelope')/mls[;2] ⍝ find the Envelope tag
              I←4 ⋄ :GoTo ∆invalid
          :Else
              envns←↑envns
              envns←(envns⍳':')↑envns ⍝ grab the namespace name
          :EndIf
         
          :If (↑⍴mls)<I←mls[;2]⍳⊂envns,'Body'
              I←2 ⋄ :GoTo ∆invalid
          :ElseIf (↑⍴mls)<I←I+1
              I←3 ⋄ :GoTo ∆invalid
          :EndIf
         
          (method mpvm)←mls[I;2 4]
         
          :If (⍴method)≥J←method⍳':' ⋄ :AndIf ~(envns,'FAULT')≡NoCase method ⋄ method←J↓method ⋄ :EndIf
         
          D←I Descendants mls[;1]
         
          :If 1<≡decoding
                            ⍝ Pluck out just this method's request-MLS or its response-MLS.
              (api type)←decoding
              methods←1⊃¨api
              :If 1∊B←2=∊⍴¨⍴¨methods ⋄ (B/methods)←(⊂⊂1 2)⊃¨B/methods ⋄ :EndIf
              :If 0=type ⋄ A←method ⋄ :Else ⋄ A←¯8↓method ⋄ :EndIf ⍝ if a response, have to drop trailing 'Response'
              :If (⍴methods)≥J←methods⍳⊂A ⋄ decoding←(J,2+type)⊃api
              :Else ⋄ decoding←0 4⍴0
              :EndIf
          :EndIf
         
          :If 0≠⍴D
              mls←mls[D;]
              B←1
         
                        ⍝ Since there are no subelements, the function call either has a simple value as
                        ⍝ its argument (in its content) or no argument at all. (I'm not even sure if a
                        ⍝ function can have content by itself but we'll allow it).
          :ElseIf ''≡3⊃mls[I;]
              R←''
              B←0
         
          :Else
              mls←mls[,I;]
              B←1
         
          :EndIf
         
          :If B
              :If noCheckArray
                  R←SOAP2APL mls
              :Else
                  (B R)←decoding SOAP2Data mls
                  :If ~B ⋄ I←5 ⋄ :GoTo ∆invalid ⋄ :EndIf
              :EndIf
          :EndIf
         
         
          R←1(method R mpvm)
         
                        ⍝ ===================================================================================
          :Return
         ∆invalid:
          :Select I
          :Case 1 ⋄ R←'The SOAP-XML is invalid.'
          :Case 2 ⋄ R←'The body (:Body) element is missing.'
          :Case 3 ⋄ R←'The procedure call element is missing.'
          :Case 4 ⋄ R←'The Envelope (:Envelope) element is missing.'
          :Case 5 ⋄ R←'Input data validation error.'
          :EndSelect
          R←0('Client.Invalid'R'')
        ∇

        ∇ R←larg ⍙EncodeMethod rarg;etag;stag;methoddata;mls;B;I;isMLS;methods;xmlencoding;encoding;api;type;method;A;methodpvm
               ⍝ Private subroutine of EncodeRequest and EncodeResponse - Encode method/data as SOAP-XML
               ⍝ -----------------------------------------------------------------------------------
               ⍝ SYNTAX:   R←isMLS encoding xmlencoding ⍙EncodeMethod method methoddata methodpvm
               ⍝
               ⍝ ARGS/RESULT:
               ⍝  method      - name of the method
               ⍝  methoddata  - data for the method (as its argument or as its result)
               ⍝  methodpvm   - PVM to apply to the method element (for a response, this is usually
               ⍝                just the same as that passed in the original SOAP request)
               ⍝  isMLS       - whether <methoddata> is intended to be an MLS (see <isMLS> in Data2SOAP).
               ⍝  encoding    - This is applicable when <isMLS> is 1.
               ⍝                  0  - do not apply any datatype tagging to any elements (presumably
               ⍝                       the receiving end will know how to work it out based on the
               ⍝                       API or WSDL)
               ⍝                  1  - apply datatype tagging to each element according to its APL
               ⍝                       datatype. However, for a given element, if its PVM contains the
               ⍝                       attribute 'xsi:type', then its value is preserved (it's not
               ⍝                       overwritten with the mapped APL datatype).
               ⍝                 [api][type] - apply datatype tagging according to the passed API:
               ⍝                  api  - associated API for any method that may be passed in rarg.
               ⍝                         This API follows the format described in API2WSDL.
               ⍝                  type - 0-request, 1-response. Note, this only needs to be passed
               ⍝                         to determine which element to pick from the relevant
               ⍝                         method's api-structure.
               ⍝                Observation: If all of the elements' datatypes are native to APL,
               ⍝                then the 3rd format for <encoding> will yield the same result as
               ⍝                <encoding>=1. It can be quite advantageous to use an API since the
               ⍝                application-developer can create new datatypes, e.g. a date (as an
               ⍝                APL string), and it will get "transformed" by virtue of getting tagged
               ⍝                with a valid SOAP datatype that means something to a consumer of the
               ⍝                SOAP. Of course, the application-developer can add the tag himself
               ⍝                (in the PVM) when constructing his MLS, but it is more elegant to not
               ⍝                have to worry about that and just let the "machinery" handle such details.
               ⍝  xmlencoding - see MLS2XML <encoding>. Default: 'UTF-8'
               ⍝  R           - SOAP-XML that is suitable for the body an HTTP request/response
               ⍝
               ⍝ SUBFNS:   APLType WHERE Data2SOAP MLS2XML
               ⍝ -----------------------------------------------------------------------------------
         
          :If (⎕DR rarg)∊82 80 160 320
              method←rarg
              methoddata←''
              methodpvm←0 2⍴⊂''
          :ElseIf 1=×/⍴rarg
              method←∊rarg
              methoddata←''
              methodpvm←0 2⍴⊂''
          :Else
              (method methoddata methodpvm)←3↑rarg,⊂0 2⍴⊂''
              (isMLS encoding xmlencoding)←larg
         
              :If 1<≡encoding
                       ⍝ Pluck out just this method's request-MLS or its response-MLS.
                  (api type)←encoding
                  methods←1⊃¨api
                  :If 1∊B←2=∊⍴¨⍴¨methods ⋄ (B/methods)←(⊂⊂1 2)⊃¨B/methods ⋄ :EndIf
                  :If 0=type ⋄ A←method ⋄ :Else ⋄ A←¯8↓method ⋄ :EndIf ⍝ if a response, have to drop trailing 'Response'
                  :If (⍴methods)≥I←methods⍳⊂A ⋄ encoding←(I,2+type)⊃api
                  :Else ⋄ encoding←0 4⍴0
                  :EndIf
              :EndIf
         
              mls←isMLS encoding Data2SOAP methoddata
         
                   ⍝ Convert real negative numbers to charvecs so that we can use the hyphen/minus
                   ⍝ character instead of the high-minus sign. It may be the case that some character
                   ⍝ conversion is performed on the result of this and it takes care of that conversion
                   ⍝ but we shouldn't depend on that.
              B←(⎕DR¨mls[;3])∊83 163 323 645
                   ⍝ We thought about using the following instead but it doesn't take care of
                   ⍝ changing '¯' for the ∆MV when it returns the typical ∆mv instead of ⎕NULL. We
                   ⍝ really should never have a SOAP-MLS carry ∆MV (∆mv or ⎕NULL) in it at all now
                   ⍝ that we're using SOAP 'null' attributes to properly describe it.
                   ⍝B←323=∆DT¨ mls[;3]
              :If 1∊B
                  I←WHERE B
                  mls[I;3]←⍕¨mls[I;3]
                  mls[I;3]←{res←⍵ ⋄ ((res='¯')/res)←'-' ⋄ res}¨mls[I;3]
              :EndIf
         
              methoddata←xmlencoding MLS2XML mls
         
          :EndIf
         
               ⍝ Be sure to at least accommodate attribute/value pairs since they "could" follow
               ⍝ the method name (passed and not being placed in the methodpvm).
          I←¯1+method⍳' '
          etag←I↑method
          stag←etag,I↓method
         
          :If 0≠↑⍴methodpvm ⋄ stag←stag,¯5↓2↓MLS2XML 1 4⍴1 'a' ''methodpvm ⋄ :EndIf
         
          R←'<?xml version="1.0"?><SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">'
          R←R,'<SOAP-ENV:Body><',stag,'>'
          R←R,methoddata
          R←R,'</',etag,'></SOAP-ENV:Body></SOAP-ENV:Envelope>'
        ∇

        ∇ R←larg ⍙SOAP2APL_Recurse rarg;A;I;J;pvm;shape;type;type_parent;B
               ⍝ Private subroutine of SOAP2APL
               ⍝ -----------------------------------------------------------------------------------
          (I type_parent)←larg
          (R pvm)←rarg
         
               ⍝ Determine the type.
          :If (↑⍴pvm)≥J←⌊/pvm[;1]⍳'xsi:type' 'type' ⍝ is there a datatype specified for this element?
              type←(⊂J 2)⊃pvm
          :ElseIf (↑⍴pvm)≥J←pvm[;1]⍳⊂'xsi:null' ⋄ :AndIf (,'1')≡⍕(⊂J 2)⊃pvm ⍝ null specified? (check this before checking on parent)
              type←'null'
          :Else
              type←type_parent ⍝ perhaps our parent contains the datatype?
          :EndIf
          :If (⍴type)≥J←type⍳':' ⋄ type←J↓type ⋄ :EndIf
         
          :Select type
          :CaseList 'int' 'float' 'double' 'boolean'
              :If (⎕DR R)∊82 80 160 320
                  :If ''≡R ⍝ (this really shouldn't be allowed since null should have been used instead)
                      R←∆MV
                  :Else
                      :If R[1]='-' ⋄ R[1]←'¯' ⋄ :EndIf
                      R←2 1⊃⎕VFI R
                  :EndIf
              :EndIf
          :Case 'Array' ⍝ (was 'SOAP-ENC:Array')
                   ⍝ Get the shape, if any.  Also, get the parent's datatype in case we need
                   ⍝ it. We'll use the parent datatype in the next call (recursive) if a given
                   ⍝ child doesn't have its own datatype specified.
              J←((-⍴A)↑¨pvm[;1])⍳⊂A←':arrayType' ⍝ (e.g. property is 'SOAP-ENC:arrayType')
              :If B←(↑⍴pvm)≥J
                  type_parent←2⊃pvm[J;]
                  J←¯1+type_parent⍳'['
                  shape←J↓type_parent ⍝ pick this up before we start modifying <type_parent>
                  type_parent←J↑type_parent
                  :If 'ur-type'≡type_parent
                           ⍝ 'ur-type' means the types for the children are mixed and should
                           ⍝ therefore be specified. Assign parent type to '' to nullify
                           ⍝ utilizing it in the next call.
                      type_parent←''
                  :EndIf
              :ElseIf (↑⍴pvm)≥J←pvm[;1]⍳⊂'xsi:null' ⋄ :AndIf (,'1')≡⍕(⊂J 2)⊃pvm ⍝ e.g. pvm is ⊃('xsi:type' 'SOAP-ENC:Array')('xsi:null' 1)
                  type_parent←'null'
              :Else
                  type_parent←''
              :EndIf
         
              I←I Children ⍙depths
              R←(I,¨⊂⊂type_parent)⍙SOAP2APL_Recurse¨⍙info[I]
         
                   ⍝ If there was a shape specified, respect it.
              :If B
                  ((shape∊',[]')/shape)←' '
                         ⍝((shape∊'[]')/shape)←' '
                  shape←2⊃⎕VFI shape
                  R←shape⍴R
              :EndIf
         
          :Case 'string'
              :If (↑⍴pvm)≥J←pvm[;1]⍳⊂'APL-ENC:shape'
                  shape←2⊃pvm[J;]
                  shape←2⊃⎕VFI shape
                  R←shape⍴R
              :EndIf
         
          :Case 'null' ⍝ comes from 1 2⍴'xsi:null' 1 or from 1 2⍴'SOAP-ENC:arrayType' 'xsd:null[S...]'
              R←∆MV
         
               ⍝:ELSE ⍝ anything unrecognized ==> no-op; leave <R> alone
         
          :EndSelect
        ∇

        NoCase←{(TOUP ⍺)⍺⍺ TOUP ⍵}


    :EndNamespace
    :Namespace WebServer

        ⎕IO  ←0 ⍝ *** DO NOT change these system variables here, only after the variables definition

⍝ === VARIABLES ===

        HOME←''

        NL←⎕av[3 2]

        stop←1


⍝ === End of variables definition ===

        ⎕IO ⎕ML ⎕WX←1 0 3

        ∇ z←FromRaw z;⎕IO
          :If 82=⊃⎕DR' '
              ⎕IO←0
              z←⎕AV[(⎕NXLATE 0)⍳8 uns z]
          :Else
              z←⎕UCS 8 uns z ⍝ 8-but unsigned integers
          :EndIf
        ∇

        ∇ r←GetAnswer(CMD BUF);URL;I;Status;Content
               ⍝ Default file handler.
               ⍝ Needs to return:
               ⍝  [1] - (charvec) HTTP status code.         This can be 0 to just mean standard success.
               ⍝  [2] - (charvec) Additional HTTP headers.  If none, just set to ''.
               ⍝  [3] - (charvec) HTTP content.             If none, just set to ''.
          :If (⊂##.HTTPUtils.lc(I←CMD⍳' ')↑CMD)∊'get ' 'post '
              URL←I↓CMD
              URL←(¯1+URL⍳' ')↑URL
              :If 'http:'≡##.HTTPUtils.lc 5↑URL ⍝ Drop leading server address
                  URL←(¯1+(+\'/'=URL)⍳3)↓URL
              :EndIf
              URL←('/'=1↑URL)↓URL
              :If 0=⍴Content←GetFile HOME,URL,(0=⍴URL)/'index.htm'
                  Status←'404 File Not Found'
              :Else
                  Status←0
              :EndIf
          :Else
              Status←'500 Invalid command: ',CMD ⋄ Content←''
          :EndIf
          r←Status''Content
        ∇

        ∇ R←GetFile NAME
          :Trap 0
              NAME ⎕NTIE ¯1
              R←⎕NREAD ¯1(⎕DR'A'),2↑⎕NSIZE ¯1
              ⎕NUNTIE ¯1
          :Else
              R←''
          :EndTrap
        ∇

        ∇ ns HandleRequest arg;FindFirst;obj;buf;pos;I;z;hdr;req;CMD;status;content;rarg;Answer;conns
               ⍝ Handle a Web Server Request
         
          FindFirst←{(⍺⍷⍵)⍳1}
          conns←⍎ns ⍝ get a reference to the namespace for the connection
          obj buf←arg
          buf←FromRaw buf
         
          :If 0=conns.⎕NC'Buffer'
              conns.Buffer←⍬
          :EndIf
          conns.Buffer,←buf
         
          pos←3+(NL,NL)FindFirst conns.Buffer
         
          :If pos>⍴conns.Buffer ⍝ Have we got everything ?
              :Return
          :ElseIf pos>I←(z←NL[2],'content-length:')FindFirst hdr←##.HTTPUtils.lc pos↑conns.Buffer
          :AndIf (⍴conns.Buffer)<pos+↑2⊃⎕VFI(¯1+z⍳NL[1])↑z←(¯1+I+⍴z)↓hdr
              :Return ⍝ a content-length was specified but we haven't yet gotten what it says to ==> go back for more
          :EndIf
         
          req←pos↑conns.Buffer
          conns.Buffer←pos↓conns.Buffer
          CMD←(¯1+req⍳NL[1])↑req
         
               ⍝ The function called is reponsible for returning:
               ⍝  [1] - (charvec) HTTP status code.         This can be 0 to just mean standard success.
               ⍝  [2] - (charvec) Additional HTTP headers.  If none, just set to ''.
               ⍝  [3] - (charvec) HTTP content.             If none, just set to ''.
         
          :Trap 0 ⍝ be sure to cover any problems during ⍎ and cover a possibly-bogus result from it
              (status hdr content)←⍎HOME,' (cmd←##.HTTPUtils.DecodeCmd req) conns'
          :Else
              ##.SAWS_Error←⎕TS ⎕LC ⎕XSI ⎕DM
              (status hdr content)←'500 Internal Server Error' '' ''
          :EndTrap
          :If status≡'200 OK' ⋄ :AndIf 1∊'text/xml'⍷hdr ⋄ content←conns.Buffer ##.ResolveNamespaces content ⋄ :EndIf
         
          rarg←req conns.Buffer ⍝ (<rarg> is for HOME to utilize, e.g. HOME≡'##.SOAP.CongaSOAP rarg'
          :If 0≡status ⋄ status←'200 OK' ⋄ :EndIf
          :If 0≠⍴hdr ⋄ hdr←(-+/∧\(⌽hdr)∊NL)↓hdr ⋄ :EndIf
          :If ##.DEBUG ##.bit 2 ⋄ :AndIf 0<⍴##.AltResponse ⋄ content←##.AltResponse ⋄ :EndIf ⍝ if directed to substitute message, do so
          :If ##.DEBUG ##.bit 1 ⋄ ##.LastRunResponse←content ⋄ :EndIf ⍝ if directed to save last transaction, do so
          :If ##.TRACE ##.bit 0
              1 ##.Output'>>> WebServer.HandleRequest <<<'
              1 ##.Output'status:  ',##.terse status~⎕UCS 10
              1 ##.Output'hdr:     ',##.terse hdr~⎕UCS 10
              1 ##.Output'content: ',##.terse content~⎕UCS 10
          :EndIf
         
          Answer←'HTTP/1.0 ',status,NL,'Content-Length: ',(⍕⍴content),NL,hdr,NL,NL
          Answer←Answer,content
         
          Answer←ToRaw Answer
          :If ~0=1⊃z←##.DRC.Send obj Answer 1 ⍝ Send response and close connection
              ##.Output'Closed socket ',obj,' due to error: ',⍕z
          :EndIf
          {}⎕EX ns ⍝ erase the namespace after the connection is closed
        ∇

        ∇ r←certpath HttpsRun arg;Common;cmd;name;port;wres;ref;nspc;sink;HOME;stop;flags;z;cert;secargs;secure;rc;objname;command;data
          ⍝ Ultra simple HTTPS (Web) Server
          ⍝ Assumes Conga available in ##.DRC
         
          certpath,←('/\'∊⍨¯1↑certpath)↓'/'
         
          {}##.DRC.Init''
          HOME port name cert flags←5↑arg,(⍴arg)↓'' 445 'HTTPSRV'(⎕NEW ##.DRC.X509Cert)0
          secure←1<cert.IsCert
          secargs←⍬
          :If secure
              {}##.DRC.SetProp'.' 'RootCertDir'certpath
              secargs←('X509'cert)('SSLValidation'flags)
          :EndIf
          →(0≠1⊃r←##.DRC.Srv name''port'Raw' 10000,secure/secargs)⍴0
          ##.Output(4×secure)↓'Non-Secure Web server ''',name,''' started on port ',⍕port
          ##.Output'Handling requests using ',HOME
          Common←⎕NS'' ⋄ stop←0
          :While ~stop
              wres←##.DRC.Wait name 10000 ⍝ Tick every 10 secs
              rc objname command data←4↑wres,(⍴wres)↓0 '' '' ''
              :Select rc
              :Case 0 ⍝ Good data from RPC.Wait
                  :Select command
                  :Case 'Error'
                      :If name≡2⊃wres ⋄ stop←1 ⋄ :EndIf
                      ##.Output'Error ',(⍕4⊃wres),' on ',2⊃wres
                      ⎕EX SpaceName 2⊃wres
                  :CaseList 'Block' 'BlockLast'
                      :If 'BlockLast'≡command
                          ⎕EX nspc
                      :Else ⋄ r←nspc HandleRequest&objname data ⍝ Run page handler in new thread
                      :EndIf
                  :Case 'Connect'
                      nspc←SpaceName 2⊃wres ⋄ nspc ⎕NS''
                      :If secure ⋄ (⍎nspc).PeerCert←2⊃##.DRC.GetProp(2⊃wres)'PeerCert' ⋄ :EndIf
                  :Else ⋄ ##.Output'Error ',⍕wres
                  :EndSelect
              :Case 100 ⍝ Time out
              :Case 1010 ⍝ Object Not found
                  ##.Output'Object ''',name,''' has been closed - Web Server shutting down'
                  :Return
              :Else
                  ##.Output'#.DRC.Wait failed:'
                  ##.Output wres
                  ∘ ⍝ intentional error
              :EndSelect
              :If 0<⎕NC'##.STOP'
                  :If ##.STOP≡1
                      stop←1
                  :EndIf
              :EndIf
          :EndWhile
          {}##.DRC.Close name
          ##.Output'Web server ''',name,''' stopped '
        ∇

        ∇ r←Run arg;HOME;port;name;Common;stop;rc;objname;command;data;nspc;wres
               ⍝ Ultra simple HTTP (Web) Server
               ⍝ Assumes Conga available in ##.DRC
          {}##.DRC.Init''
          HOME port name←3↑arg,(⍴arg)↓'' 8080 'HTTPSRV'
          →(0≠1⊃r←##.DRC.Srv name''port'Raw' 10000)⍴0 ⍝
          ##.Output'Web server ''',name,''' started on port ',⍕port
          ##.Output'Handling requests using ',HOME
          Common←⎕NS'' ⋄ stop←0
          :While ~stop
              wres←##.DRC.Wait name 10000 ⍝ Tick every 10 secs
              rc objname command data←4↑wres,(⍴wres)↓0 '' '' ''
              :Select rc
              :Case 0 ⍝ Good data from RPC.Wait
                  :Select command
                  :Case 'Error'
                      :If name≡objname ⋄ stop←1 ⋄ :EndIf
                      ##.Output'Error ',(⍕data),' on ',objname
                      ⎕EX SpaceName objname
                  :CaseList 'Block' 'BlockLast'
                      :If 0=⎕NC nspc←SpaceName objname ⋄ nspc ⎕NS'' ⋄ :EndIf ⍝ create namespace for command
                      :If 'BlockLast'≡command ⍝ if we got a blocklast, the connection has been closed...
                          ⎕EX nspc ⍝ just cleanup the namespace
                      :Else ⋄ r←nspc HandleRequest&objname data ⍝ Run page handler in new thread
                      :EndIf
                  :Case 'Connect' ⍝ Ignore
                  :Else ⋄ ##.Output'Error ',⍕wres
                  :EndSelect
              :Case 100 ⍝ Time out - put any "housekeeping" code here
              :Case 1010 ⍝ Object Not found
                  ##.Output'Object ''',name,''' has been closed - Web Server shutting down'
                  :Return
              :Else
                  ##.Output'#.DRC.Wait failed:'
                  ##.Output wres
                  ∘ ⍝ intentional error
              :EndSelect
              :If 0<⎕NC'##.STOP'
                  :If ##.STOP≡1
                      stop←1
                  :EndIf
              :EndIf
          :EndWhile
          {}##.DRC.Close name
          ##.Output'Web server ''',name,''' stopped '
        ∇

        ∇ r←SpaceName cmd
               ⍝ Generate namespace name from rpc command name
          r←'Common.C',Subst(2⊃{1↓¨('.'=⍵)⊂⍵}'.',cmd)'-=' '_∆'
        ∇

        ∇ r←Subst arg;i;m;str;c;rep
               ⍝ Substictute character c in str with rep
          str c rep←arg
          i←c⍳str
          m←i≤⍴c
          (m/str)←rep[m/i]
          r←str
        ∇

        ∇ r←TimeServer(CMD BUF);t
               ⍝ Example function for "RPC Server".
         
               ⍝ Needs to return:
               ⍝  [1] - (charvec) HTTP status code.         This can be 0 to just mean standard success.
               ⍝  [2] - (charvec) Additional HTTP headers.  If none, just set to ''.
               ⍝  [3] - (charvec) HTTP content.             If none, just set to ''.
         
          :If (⊂##.HTTPUtils.lc CMD.Command)∊'get' 'post'
              t←,'ZI2,<:>,ZI2,<:>,ZI2'⎕FMT 1 3⍴3↓⎕TS
              r←0 ''('The time is ',t,' and you asked for the page:',CMD.Page)
         
          :Else
              r←('500 Invalid command: ',CMD.Command)'' ''
          :EndIf
        ∇

        ∇ z←ToRaw z;⎕IO
          :If ⊃80≠⎕DR' '
              ⎕IO←0
              z←(⎕NXLATE 0)[⎕AV⍳z]
          :Else
              z←8 int ⎕UCS z ⍝ 8-bit signed integers
          :EndIf
        ∇

          int←{ ⍝ Signed from unsigned integer.
              ↑⍵{(⍺|⍵+⍺⍺)-⍵}/2*⍺-0 1
          }

          uns←{ ⍝ Unsigned from signed integer.
              (2*⍺)|⍵
          }

        :Namespace cmd
⍝ === VARIABLES ===

            Arguments←0 2⍴⊂''

            Command←'post'

            Headers←4 2⍴'host' ' localhost' 'soapaction' ' "http://localhost/MyWebService/Regression"' 'content-type' ' text/xml; charset=utf-8' 'content-length' ' 500'

            Input←'post /mywebservice http/1.1'

            Page←'/mywebservice '


⍝ === End of variables definition ===

            ⎕IO ⎕ML ⎕WX←1 0 3

        :EndNamespace
    :EndNamespace
:EndNamespace