﻿:namespace WSutils

    (⎕ml ⎕io)←1

    if←/⍨

    ∇ r←lev Help Cmd;a;getex;p;sw;t
      :Access Shared Public
      sw←'The argument may be omitted in which case everything is assumed.' 'The names searched MUST exist in the current namespace.'
      sw,←'-format  displays result as )FNS would (*)' '-regex   uses full regular expression (see http://msdn.microsoft.com/en-us/library/az24scfc.aspx)'
      sw,←⊂'-date    takes a value, or a pair of [YY]MMDD values (for from-to) possibly preceded by > or <'
      sw,←⊂'-noclass removes the class number after the name'
      sw,←⊂'(*) -format is implied if the command was entered on the command line and the result was not captured.'
      sw,←⊂'            It can also be disabled by entering -format=no'
     
      p←⊂'Arg: patterns; Returns a message summarizing the process'
      r←⊂p,sw,⊂'-offset where to align comments (default 40)'                                    ⍝ align
      r,←⊂p,sw                                                                                   ⍝ reorderlocals
      r,←⊂(⊂'Arg: pattern; Produces a list of fns & ops whose names match the pattern'),sw       ⍝ fnsLike
      r,←⊂(⊂'Arg: pattern; Produces a list of vars & nss whose names match the pattern'),sw      ⍝ varsLike
      r,←⊂(⊂'Arg: pattern; Produces a list of names matching the pattern'),sw                    ⍝ namesLike
      t←⊂'Arg: pattern; Produces a list of vars & nss matching the pattern along with their size in decreasing order'
      r,←⊂t,sw[⍳2],'-top=   show only the top N values' '-class= restrict the class to the value specified' ⍝ sizeof
      r←↑t←↑r[AllCmds⍳⊂Cmd]
      →lev↓0 ⋄ r←t
     
     ⍝ ?? help section
      getex←{1↓¨(⍵[1]+1)↓⍵[2]↑⎕NR'Help'}
      :Select ⊂Cmd
     os: :Case AllCmds[1]
⍝
⍝ Example: align the inline comments at col 16 for fn <Fa>
⍝      ⎕VR 'Fa'
⍝     ∇ Fa     ⍝ header rmk
⍝[1]    no eol'⍝'here
⍝[2]    this line at 16        ⍝ no ⍝ in above line
⍝[3]
⍝[4]   ⍝ Empty line above
⍝[5]    long line exceeding col  ⍝1 space added only
⍝[6]       ⍝ Comment line untouched
⍝[7]    'line with ⍝'    ⍝ c1
⍝[8]    dif2a        ⍝1 space will be inserted
⍝[9]    same3           ⍝     leading spaces deleted
⍝     ∇
⍝
⍝      ]commentalign  Fa -offset=16
⍝ 1  functions processed,  1  modified
⍝Fa
⍝      ⎕VR 'Fa'
⍝     ∇ Fa             ⍝ header rmk
⍝[1]    no eol'⍝'here
⍝[2]    this line at 16 ⍝ no ⍝ in above line
⍝[3]
⍝[4]   ⍝ Empty line above
⍝[5]    long line exceeding col ⍝ 1 space added only
⍝[6]       ⍝ Comment line untouched
⍝[7]    'line with ⍝'  ⍝ c1
⍝[8]    dif2a          ⍝ 1 space will be inserted
⍝[9]    same3          ⍝ leading spaces deleted
⍝     ∇
     oe:  r,←getex os oe
     
     rs: :Case AllCmds[2]
⍝
⍝ Example: reorder the locals in all fns starting with F:
⍝      ⎕vr 'Fnml'
⍝     ∇ Fnml;⎕IO;X;⍙;a;_;aa;Aa;aaAA;aA;⎕PP ⍝ locals anyone?
⍝[1]    ...
⍝     ∇
⍝
⍝      ]reord  F*
⍝3 fns processed, 1 changed
⍝      ⎕vr 'Fnml'
⍝     ∇ Fnml;a;aa;aA;Aa;aaAA;X;⍙;_;⎕IO;⎕PP ⍝ locals anyone?
⍝[1]    ...
⍝     ∇
     re:  r,←getex rs re
     
     fs: :Case AllCmds[3]
⍝
⍝ Example: find all fns/ops whose name starts with F and display like )FNS:
⍝      ]fnsLike  F*
⍝ Fa   Fb    Fc
⍝
⍝ Example: return the names of fns/ops whose name contains the string 'ex' after Feb 5th:
⍝      ]fns  *ex*   -date= >205
⍝ regex  texico
     fe:  r,←getex fs fe
     
     vs: :Case AllCmds[4]
⍝
⍝ Example: find all variables or namespaces starting with F and display like )VARS:
⍝      ]varsLike  F*
⍝ Fa   Fbc    Fxyz
⍝
⍝ Example: return the names of vars/spaces whose name contains the same vowel repeated 3 times:
⍝      ]vars ([aeuoi])\1\1  -regex
⍝ ooops
⍝ weee
     ve:  r,←getex vs ve
     
     ns: :Case AllCmds[5]
⍝
⍝ Example: find all 3 letter names and display like )VARS:
⍝      ]namesLike  ???
⍝ aaa.2 dsa.2 fds.2 foo.3 goo.3
⍝
⍝ Example: return the names of objects whose name contains the same vowel repeated 3 times:
⍝      ]names ([aeuoi])\1\1  -regex  -noclass
⍝ ooops  weee
     ne:  r,←getex ns ne
     
     ss: :Case AllCmds[6]
⍝
⍝ Example: find the size of the 3 largest vars:
⍝      ]size  -top=3  -class=2 9
⍝ m   1124
⍝ aa   912
⍝ XYZ  124
⍝
⍝ Example: return the size of all 3 letter fns/ops:
⍝      ]size  ??? -class=3 4
⍝ axe 1321
⍝ wee  222
     se:  r,←getex ss se
     
      :EndSelect
      r←↑r
    ∇
    
    AllCmds←'commentAlign' 'reordLocals' 'fnsLike' 'varsLike' 'namesLike' 'sizeof'

    ∇ r←List;i
      :Access Shared Public
      r←⎕NS¨(⍴AllCmds)⍴⊂''
      r.Group←⊂'wsutils'
      i←'-format[=]no NO -regex -date='
      r.Parse←('-offset= ',i)i i'-regex -format[=]no NO'i'-top= -class='
      r.Name←AllCmds
      i←0
      r[i←i+1].Desc←'Align all end-of-line-comments to start at a specific offset'
      r[i←i+1].Desc←'Reorders the locals in the header of fns/ops matching the pattern'
      r[i←i+1].Desc←'Returns a list of fns/ops matching the pattern'
      r[i←i+1].Desc←'Returns a list of vars matching the pattern'
      r[i←i+1].Desc←'Returns a list of names followed by their class matching the pattern'
      r[i].Parse,←' -noclass'
      r[i←i+1].Desc←'Returns the size of the variables in descending order'
    ∇

    ∇ r←Run(Cmd Args);addclass;allowed;at;b;c;cfn;col;date;DATE;dates;DOS;n;names;nc;ok;ref;show;sz;t;WIN;l1
      :Access Shared Public
      WIN←⍬⍴'Windows'⍷1⊃'.'⎕WG'APLVersion'
      ref←##.THIS
      show←↑ ⋄ addclass←{' '~⍨⍵,'.',⍕ref.⎕NC ⍵}⍣((Cmd≡'namesLike')>Args.Switch'noclass')
      DOS←~Args.Switch'regex' ⍝ assume DOS regular expression
      :If ~(⊂Args.Switch'format'){⍺∊'no' 'NO':1 ⋄ 6::⍵ ⋄ ##.RIU}0  ⍝ is the result used?
          show←⎕PW 1∘⎕SE.Dyalog.Utils.showCol
      :EndIf
      nc←(c←AllCmds⍳⊂Cmd)⊃(3 4)(3 4 9.1 9.4)(3 4)(2 9)(⍳9)(2 9 Args.Switch'class')
      names←ref.⎕NL nc
      :If ∨/3 4∊nc ⍝ -date is for all but SIZE
      :AndIf 0≢DATE←Args.Switch'date'
          'only one comparison fn allowed'⎕SIGNAL 11 if 1<⍴t←DATE∩allowed←'<≤≥>-=≠' ⋄ cfn←⍎t←1↑t,'='
          'incorrect number of dates'⎕SIGNAL 11 if(0 1='-'∊t)⍱.∧1 2=⍴dates←2⊃⎕VFI DATE{b\⍺/⍨b←~⍺∊⍵}allowed
          ok←('='∊t)∧(dates≡,0)∧0=at←100∘⊥∘(3∘↑)¨,0 1 0 0/ref.⎕AT names ⍝ keep all those without a timestamp unless required
     
         ⍝ We allow short dates and defaults are supplied for the century, the year and the month
          dates+←(20000000,10000 100×100|2↑⎕TS)+.×1000000 10000 100∘.>dates ⍝ pad century, year, month need be
          :If '-'∊t ⋄ cfn←{(⍺≥1↑⍵)∧⍺≤1↓⍵} ⋄ :EndIf
          ok∨←at cfn dates
          names←ok⌿names
      :EndIf
      'dotted.names are illegal'⎕SIGNAL 11 if 1∊(DOS↓'\.')⍷⍕t←Args.Arguments
      :If (0<⍴t)>0∊⍴r←names ⍝ any pattern to use?
          r←↑∪↓⊃cat1/names∘namesLike¨t
      :EndIf
      l1←''
      :If ~0∊⍴r ⍝ any name found?
          :If 'commentAlign'≡Cmd
              col←40 Args.Switch'offset'
              r←col ref Align{⍵[⎕AV⍋⍵;]}r
          :ElseIf 'sizeof'≡Cmd
              n←⍴t←⍒sz←ref.⎕SIZE r
              r←(rtb r[t;]),' ',⍕sz[t∘.+,0]
              :If 0≠t←n Args.Switch'top' ⋄ r←r↑[1]⍨(×t)×n⌊|t ⋄ :EndIf
          :ElseIf 'reordLocals'≡Cmd
              l1←' objects processed',⍨⍕⍴t←ref ohl¨↓r
              l1,←', ',(⍕1+.=t),' changed'
              :If 0<n←+/t<0 ⋄ l1,←', ',(⍕n),' failed' ⋄ :EndIf
              r←(t>0)⌿r
          :EndIf
      :EndIf
      r←show addclass¨↓r
      :If 0<⍴l1 ⋄ r←0 1↓⍕2 1⍴l1 r ⋄ :EndIf
    ∇

    ∇ header←sortlocals header;c;h;m;newh;so
     ⍝ Sort a header line
      (h c)←{i←¯1+⍵⍳'⍝' ⋄ (rtb i↑⍵)(i↓⍵)},header
      →0 if 3>⍴m←{(⍵∊';')⊂⍵}';',h
      so←' ',⊖2 28⍴⎕A,'⍙_abcdefghijklmnopqrstuvwxyz∆⎕'
      →0 if h≡newh←1↓∊∪m[1,1+so⍋1 1↓↑m] ⍝ sort
      header←newh,' ',c
    ∇

    ∇ new←ns ohl fn;cr;h;l;newh ⍝ 0=not new, 1=new, ¯1=failed
    ⍝ Order Header Locals.
      :If new←~9∊ns.⎕NC fn←fn~' '
          →0↓⍨new←h≢newh←sortlocals h←1⊃cr←ns.⎕NR fn ⍝ cut line 0
          (1⊃cr)←newh ⋄ new←¯1*fn≢ns.⎕FX cr
      :Else
          →0 if 0≡cr←{0::0 ⋄ ⎕SRC ⍵}ns⍎fn ⍝ non-scripted nss are skipped
          →0 if 0=⍴h←(l←'∇'=⊃¨rlb¨cr)/cr
          →0 if h≡newh←sortlocals¨h
          (l/cr)←newh
          :Trap 11 ⋄ new←1{⍺}ns.⎕FIX cr ⋄ :EndTrap
      :EndIf
    ∇

⍝ Patterns, here, are the limited version where ? mean 1 character
⍝ and * means any series of characters. Ex: abc*def means "a name starting
⍝ with 'abc' and ending with 'def'".

    ∇ r←mat namesLike pattern;b;bpat;NL;nr;pat;pos;vec;⎕IO
    ⍝ Return lines in mat that match the pattern
    ⍝ Trailing spaces in mat are ignored
      r←0 0⍴'' ⋄ ⎕IO←0 ⋄ NL←2⊃⎕AV
      vec←NL ⎕SE.Dyalog.Utils.toVector mat ⍝ ensure vector
      :If 0<nr←1↑⍴mat
          :If DOS  ⍝ DOS mode?
             ⍝ Then replace ? by . and * by .* (note expression remains REGEX)
             ⍝ This only changes the meaning of *, ? and automatically anchors the pattern
              b←'?'=pat←pattern ⋄ (b/pat)←'.' ⋄ b←pat='*' ⋄ (b/pat)←⊂'.*'
              pattern←'∧',∊pat,DOS/'$' ⍝ and make it start at the beginning and end at the end
          :EndIf
          pos←PATMATCH pattern vec
          r←mat[∪(+\NL=vec)[pos[;0;0]~⍴vec];] ⍝ remove hit at the end
      :EndIf
    ∇

    ∇ {mod}←la Align arg;b;code;col;cr;fi;fn;i;lamp;lines;lpos;m;mod;n;nr;ns;t;⎕IO
    ⍝ Align comments in fns in matrix ARG at col in namespace
      (col ns)←la ⋄ m←⎕IO←0 ⋄ mod←0⍴⍨n←1↑⍴arg
      :For fi :In ⍳n
          :If ~(ns.⎕NC fn←arg[fi;]~' ')∊3 4
              ⎕←'<',fn,'> is not a function' ⋄ n-←1
          :ElseIf 326≠⎕DR cr←ns.⎕CR fn ⍝ take a copy to see if anything has changed
          :AndIf 0<⍴i←i/⍳⍴i←∨/lamp←<\('⍝'=cr)∧=\''''≠cr ⍝ and ignore fns with refs
             ⍝ See where comments need alignment
              lpos←⍳∘1¨↓lamp[i;] ⋄ b←(lpos↑¨lines←↓cr[i;])∨.≠¨' '
          :AndIf ∨/b
              (i lpos lines)←b∘/¨i lpos lines
             ⍝ Pad code with at least 1 space to align the comments
              code←(col⌈1+⍴¨code)↑¨code←rtb¨lpos↑¨lines
             ⍝ Add the ⍝, add a space and the comments
              nr←↓cr ⋄ nr[i]←code,¨'⍝ '∘,¨rlb¨(lpos+1)↓¨lines
              :If 0∊1↑0⍴ns.⎕FX nr
                  ⎕←'*** Unable to refix function <',fn,'>'
              :Else
                  mod[fi]←m+←cr≢ns.⎕CR fn ⍝ any changes?
              :EndIf
          :EndIf
      :EndFor
      ⎕←n'functions processed,'m'modified'
      mod←mod⌿arg
    ∇

    ∇ r←a cat1 b
   ⍝ a ,[⎕io] b for character matrices
      r←0 1↓0 ¯1↓⎕FMT 2 1⍴a b
    ∇

    rtb←{rk←-⍴⍴b←' '=⍵ ⋄ (rk↑-⊥⍨∧⌿⍣(¯2∊rk)+b)↓⍵} ⍝ Remove Trailing Blanks
    rlb←{(+/∧\' '=⍵)↓⍵}                          ⍝ Remove Leading  Blanks

    ∇ r←{options}PATMATCH arg;BS;C;code;CR;e;good;ind;len;LF;lp;ls;mask;mo;N;notalpha;np;NULL;pattern;ptr;regcomp;regerror;regexec;regfree;rs;sl;string;sxi;syn;z;⎕IO;⎕USING;⎕WX
⍝ This function returns an int list indicating the start & length of each match.
⍝ Each subexpression specified is shown for each match (3D result).
⍝ This fn is ⎕io independent.
⍝ Pattern may not overlap.
⍝ ls/rs are left/right "syntactic" op. They work with 'notalpha' (see below).
⍝ 'mask' is where matches must occur entirely.
⍝
      arg←arg,(⍴arg)↓0 0 0 '' 0
      (pattern string notalpha mask syn)←,¨arg
      mask←mask,((0∊⍴mask)×⍴string)⍴1
      notalpha←notalpha∧1,mask,1
     
      ⎕WX←1 ⋄ ⎕IO←0 ⋄ N←'' ⋄ sl←'\'≠¯1↓'x',pattern
      ⎕SHADOW'⎕ml' ⋄ ⎕ML←0 ⋄ (BS LF CR)←⎕TC
      e←(⍴pattern)↑'∧'=1↑pattern ⍝ BOL anchor
      ((e∨¯1⌽sl∧'[∧'⍷pattern)/pattern)←⎕AV[235] ⍝ map ∧ to ASCII caret if no translation done
     
      good←e/⍳⍴e←sl∧'⍵'=pattern ⍝ numbers before ⍺ tokens
    ⍝ For APL code we accept ⍺ & ⍵ as shortcuts for 'object name' and 'number'
      :If 1∊e←sl∧'⍺'=pattern
          r←⎕NC 256 1⍴⎕AV ⋄ lp←,⎕AV[(⎕AV⍳'Aa')∘.+⍳26]
          r←0≤r ⍝ this varies from one APL to another
          r←'a-zA-Z',(r⌿⎕AV)~lp
          pattern[e/⍳⍴e]←⊂'(?>\b[',r,'][',r,'0-9]*\b|⍺⍺|⍺|⍵⍵|⍵)'
      :EndIf
      pattern[good]←⊂'(?>¯?(?<!\w)(?:\d+\.?\d*|\d*\.?\b\d+)(?:[eE]¯?\d+)?(?!\w))' ⍝ atomic grouping
      pattern←⊃,/pattern,⊂'' ⍝ cover empty case
      pattern←(~'\⍺'⍷e)/e←(~'\⍵'⍷e)/e←pattern
      r←1++/'('=pattern
      r←0⍴⊂(r,2)⍴0 ⍝ default result
     
    ⍝ Determine the options
      ⎕USING←'System.Text.RegularExpressions,system.dll'
      :If 0=⎕NC'options' ⋄ options←RegexOptions.Multiline ⋄ :EndIf
     
    ⍝ Mask out unwanted positions by using BS
      string[e/⍳⍴e←~mask]←BS
     
    ⍝ Change CR into NL if needed
      :If 'Multiline'≡⍕options
          string[e/⍳⍴e←string=CR]←LF
      :EndIf
     
      mo←Regex.Match string pattern options
     
    ⍝ Execute the expression until nothing found
      :While good←mo.Success
          (len ind)←mo.(Length Index)
          :If ∨/syn
    ⍝ 'notalpha' is where no name forming chars are (padded 1 left and right to avoid INDEX error)
    ⍝ This supplements the ability of the engine to detect word characters with \w as Dyalog
    ⍝ also uses other characters like Á. 'notalpha' can indicate where those are.
              good←notalpha[len+0,ind]∧.≥syn
          :EndIf
          good←good∧∧/len↑ind↓mask
          :If good
              np←mo.Groups.Count
              r←r,⊂↑(mo.Groups.Item¨⍳np).(Index Length)
          :EndIf
          mo←mo.NextMatch
      :EndWhile
     
     end:
      r←↑r ⍝ disclose results
    ∇

:Endnamespace